Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.conf
Class OpenJPAConfigurationImpl

    java.lang.Object
      org.apache.openjpa.lib.conf.ConfigurationImpl
          org.apache.openjpa.conf.OpenJPAConfigurationImpl

All Implemented Interfaces:
  BeanInfo, Externalizable, Serializable, Cloneable, OpenJPAConfiguration, Configuration, ValueListener, Closeable

Direct Known Subclasses:
  JDBCConfigurationImpl, XMLConfiguration

    public class OpenJPAConfigurationImpl

extends ConfigurationImpl
implements OpenJPAConfiguration

Implementation of the `OpenJPAConfiguration` interface.

Author:
  Marc Prud'hommeaux, Abe White
See Also:
  `ConfigurationImpl`, Serialized Form

Field Summary
`PluginListValue` | `aggregateListenerPlugins`
`ObjectValue` | `auditorPlugin`
`IntValue` | `autoClear`
`AutoDetachValue` | `autoDetach`
`BrokerFactoryValue` | `brokerFactoryPlugin`
`BrokerValue` | `brokerPlugin`
`ObjectValue` | `cacheDistributionPolicyPlugin`
`CacheMarshallersValue` | `cacheMarshallerPlugins`
`ObjectValue` | `callbackPlugin`
`ObjectValue` | `classResolverPlugin`
`ObjectValue` | `compatibilityPlugin`
`StringValue` | `connection2DriverName`
`StringValue` | `connection2Password`
`StringValue` | `connection2Properties`
`StringValue` | `connection2URL`
`StringValue` | `connection2UserName`
`StringValue` | `connectionDriverName`
`ObjectValue` | `connectionFactory`
`ObjectValue` | `connectionFactory2`
`StringValue` | `connectionFactory2Name`
`StringValue` | `connectionFactory2Properties`
`BooleanValue` | `connectionFactoryMode`
`StringValue` | `connectionFactoryName`
`StringValue` | `connectionFactoryProperties`
`StringValue` | `connectionPassword`
`StringValue` | `connectionProperties`
`IntValue` | `connectionRetainMode`
`StringValue` | `connectionURL`
`StringValue` | `connectionUserName`
`ObjectValue` | `dataCacheManagerPlugin`
`StringValue` | `dataCacheMode`
`ObjectValue` | `dataCachePlugin`
`IntValue` | `dataCacheTimeout`
`ObjectValue` | `detachStatePlugin`
`BooleanValue` | `dynamicDataStructs`
`BooleanValue` | `dynamicEnhancementAgent`
`BooleanValue` | `eagerInitialization`
`PluginValue` | `encryptionProvider`
`IntValue` | `fetchBatchSize`
`StringListValue` | `fetchGroups`
`PluginListValue` | `filterListenerPlugins`
`PluginValue` | `finderCachePlugin`
`IntValue` | `flushBeforeQueries`
`BooleanValue` | `ignoreChanges`
`ObjectValue` | `instrumentationManager`
`PluginListValue` | `instrumentationProviders`
`ObjectValue` | `inverseManagerPlugin`
`ObjectValue` | `lifecycleEventManager`
`ObjectValue` | `lockManagerPlugin`
`IntValue` | `lockTimeout`
`ObjectValue` | `managedRuntimePlugin`
`StringValue` | `mapping`
`IntValue` | `maxFetchDepth`
`PluginValue` | `metaFactoryPlugin`
`protected MetaDataRepository` | `metaRepository`
`MetaDataRepositoryValue` | `metaRepositoryPlugin`
`BooleanValue` | `multithreaded`
`BooleanValue` | `nontransactionalRead`
`BooleanValue` | `nontransactionalWrite`
`BooleanValue` | `optimistic`
`BooleanValue` | `optimizeIdCopy`
`ObjectValue` | `orphanedKeyPlugin`
`BooleanValue` | `postLoadOnMerge`
`PluginValue` | `preparedQueryCachePlugin`
`ObjectValue` | `proxyManagerPlugin`
`ObjectValue` | `queryCachePlugin`
`QueryCompilationCacheValue` | `queryCompilationCachePlugin`
`IntValue` | `queryTimeout`
`IntValue` | `readLockLevel`
`BooleanValue` | `refreshFromDataCache`
`protected RemoteCommitEventManager` | `remoteEventManager`
`RemoteCommitProviderValue` | `remoteProviderPlugin`
`IntValue` | `restoreState`
`BooleanValue` | `retainState`
`BooleanValue` | `retryClassRegistration`
`IntValue` | `runtimeUnenhancedClasses`
`ObjectValue` | `savepointManagerPlugin`
`ObjectValue` | `seqPlugin`
`ObjectValue` | `specification`
`BooleanValue` | `transactionMode`
`ObjectValue` | `validationFactory`
`StringValue` | `validationGroupPrePersist`
`StringValue` | `validationGroupPreRemove`
`StringValue` | `validationGroupPreUpdate`
`StringValue` | `validationMode`
`ObjectValue` | `validator`
`IntValue` | `writeLockLevel`

Fields inherited from class org.apache.openjpa.lib.conf.ConfigurationImpl
`id, logFactoryPlugin`

Fields inherited from interface org.apache.openjpa.conf.OpenJPAConfiguration
`LOG_DATACACHE, LOG_ENHANCE, LOG_METADATA, LOG_QUERY, LOG_RUNTIME, LOG_TOOL, OPTION_DATASTORE_CONNECTION, OPTION_EMBEDDED_COLLECTION_RELATION, OPTION_EMBEDDED_MAP_RELATION, OPTION_EMBEDDED_RELATION, OPTION_ID_APPLICATION, OPTION_ID_DATASTORE, OPTION_INC_FLUSH, OPTION_JDBC_CONNECTION, OPTION_NONTRANS_READ, OPTION_NULL_CONTAINER, OPTION_OPTIMISTIC, OPTION_POSTLOAD_ON_MERGE, OPTION_QUERY_SQL, OPTION_TYPE_ARRAY, OPTION_TYPE_COLLECTION, OPTION_TYPE_MAP, OPTION_VALUE_AUTOASSIGN, OPTION_VALUE_INCREMENT`

Fields inherited from interface org.apache.openjpa.lib.conf.Configuration
`ATTRIBUTE_ALLOWED_VALUES, ATTRIBUTE_CATEGORY, ATTRIBUTE_INTERFACE, ATTRIBUTE_ORDER, ATTRIBUTE_TYPE, ATTRIBUTE_XML, INIT_STATE_FREEZING, INIT_STATE_FROZEN, INIT_STATE_LIQUID`

Fields inherited from interface java.beans.BeanInfo
`ICON_COLOR_16x16, ICON_COLOR_32x32, ICON_MONO_16x16, ICON_MONO_32x32`

Constructor Summary
`OpenJPAConfigurationImpl()` Default constructor.
`OpenJPAConfigurationImpl(boolean loadGlobals)` Constructor.
`OpenJPAConfigurationImpl(boolean derivations, boolean loadGlobals)` Constructor.

Method Summary
`AggregateListener[]` | `getAggregateListenerInstances()` Return the query function listeners.
`String` | `getAggregateListeners()` A comma-separted list of the plugin strings of the query `AggregateListener`s to use.
`String` | `getAuditor()` Gets the plug-in string of `Auditor` specified in this configuration.
`Auditor` | `getAuditorInstance()` Gets the singular instance of `Auditor` associated with this configuration.
`String` | `getAutoClear()` Whether instances clear their state when entering a transaction.
`int` | `getAutoClearConstant()` Return the `AutoClear` constant.
`String` | `getAutoDetach()` A comma-separated list of events which trigger auto-detachment in place of managed states.
`int` | `getAutoDetachConstant()` The `AutoDetach` flags.
`String` | `getBrokerFactory()` The `BrokerFactory` class to use.
`BrokerFactoryEventManager` | `getBrokerFactoryEventManager()` Return the `BrokerFactoryEventManager` associated with this configuration.
`String` | `getBrokerImpl()` The plugin string of the `BrokerImpl` extension to create.
`String` | `getCacheDistributionPolicy()` Gets the plug-in string that described the policy to distribute cached instances across named partitions of L2 data cache.
`CacheDistributionPolicy` | `getCacheDistributionPolicyInstance()` Gets the policy object that determines distribution of cached instances across named partitions of L2 data cache.
`Map` | `getCacheMarshallerInstances()` Return the cache marshaller listeners.
`String` | `getCacheMarshallers()` A comma-separted list of the plugin strings specifying the `CacheMarshaller`s to use.
`String` | `getCallbackOptions()` Options for configuring callbacks as a String.
`CallbackOptions` | `getCallbackOptionsInstance()` Options for configuring callbacks.
`String` | `getClassResolver()` The plugin string for the `ClassResolver` to use for custom class loading.
`ClassResolver` | `getClassResolverInstance()` The `ClassResolver` to use.
`String` | `getCompatibility()` Backwards compatibility options.
`Compatibility` | `getCompatibilityInstance()` If a Compatibility instance is associated with the Specification, we will configure this Compatibility instance instead of instantiating a new one so that the compatibility flags set in compliance with the Specification can be preserved.
`Log` | `getConfigurationLog()` Returns the logging channel `openjpa.Runtime` by default.
`String` | `getConnection2DriverName()` Class name of the non-XA connection driver.
`String` | `getConnection2Password()` The password for the non-XA data store connection.
`String` | `getConnection2Properties()` These properties provide any additional information needed to establish non-XA connections.
`String` | `getConnection2URL()` The URL for the non-XA data store connection.
`String` | `getConnection2UserName()` The user name for the non-XA data store connection.
`String` | `getConnectionDriverName()` Class name of the connection driver.
`Object` | `getConnectionFactory()` The connection factory, possibly from JNDI.
`Object` | `getConnectionFactory2()` The non-XA connection factory.
`String` | `getConnectionFactory2Name()` The name for the second data store connection factory.
`String` | `getConnectionFactory2Properties()` Configuration properties for the non-XA connection factory.
`String` | `getConnectionFactoryMode()` The mode of the connection factory in use.
`String` | `getConnectionFactoryName()` The name for the data store connection factory.
`String` | `getConnectionFactoryProperties()` Configuration properties for the connection factory.
`String` | `getConnectionPassword()` The password for the data store connection.
`String` | `getConnectionProperties()` These properties provide any additional information needed to establish connections.
`String` | `getConnectionRetainMode()` Specifies the behavior of the broker with respect to data store connections.
`int` | `getConnectionRetainModeConstant()` Return the connection retain mode as one of the following symbolic constants: `ConnectionRetainModes.CONN_RETAIN_ALWAYS` `ConnectionRetainModes.CONN_RETAIN_TRANS` `ConnectionRetainModes.CONN_RETAIN_DEMAND`
`String` | `getConnectionURL()` The URL for the data store connection.
`String` | `getConnectionUserName()` The user name for the data store connection.
`String` | `getDataCache()` The `DataCache` to use for level-2 data store caching.
`String` | `getDataCacheManager()` The data cache manager manages this configuration's cache instances.
`DataCacheManager` | `getDataCacheManagerInstance()` The data cache manager manages this configuration's cache instances.
`String` | `getDataCacheMode()` Return the String constant that matches the `DataCacheMode`
`int` | `getDataCacheTimeout()` Default data cache timeout.
`String` | `getDetachState()`
`DetachOptions` | `getDetachStateInstance()` Return the instance specified by the detach state plugin.
`boolean` | `getDynamicDataStructs()` Return whether to generate dynamic data structures where possible for cache and runtime usage.
`boolean` | `getDynamicEnhancementAgent()` Whether OpenJPA will attempt to dynamically load the enhancement agent.
`EncryptionProvider` | `getEncryptionProvider()` Gets the `EncryptionProvider`.
`int` | `getFetchBatchSize()` Get the size of the batch that will be pre-selected when accessing elements in a query or relationship.
`String` | `getFetchGroups()` Comma-separated list of fetch group names that will be pre-set for all new `FetchConfiguration`s.
`String[]` | `getFetchGroupsList()` List of fetch group names that will be pre-set for all new `FetchConfiguration`s.
`FilterListener[]` | `getFilterListenerInstances()` Return the query filter listeners.
`String` | `getFilterListeners()` A comma-separted list of the plugin strings of the query `FilterListener`s to use.
`String` | `getFinderCache()` Get the string configuration of the finder cache.
`FinderCache` | `getFinderCacheInstance()` Get the cache of finder queries.
`String` | `getFlushBeforeQueries()` Returns whether or not OpenJPA should automatically flush modifications to the data store before executing queries.
`int` | `getFlushBeforeQueriesConstant()` Returns one of `QueryFlushModes.FLUSH_TRUE`, `QueryFlushModes.FLUSH_FALSE`, or `QueryFlushModes.FLUSH_WITH_CONNECTION`, as determined by parsing the string returned by `OpenJPAConfiguration.getFlushBeforeQueries()`.
`boolean` | `getIgnoreChanges()` Whether changes in the current transaction are taken into account when executing queries and iterating extents.
`String` | `getInstrumentation()` Gets the plug-in string that defines instrumentation providers and what they instrument.
`InstrumentationProvider[]` | `getInstrumentationInstances()`
`String` | `getInstrumentationManager()`
`InstrumentationManager` | `getInstrumentationManagerInstance()` Gets an instance of the instrumentation manager.
`String` | `getInverseManager()` The plugin to use for managing inverse relations.
`String` | `getLifecycleEventManager()` Gets the lifecycle event manager instance classname.
`LifecycleEventManager` | `getLifecycleEventManagerInstance()` Gets the lifecycle event manager instance.
`String` | `getLockManager()` The plugin to use for datastore lock management.
`int` | `getLockTimeout()` The time to wait for an object lock in milliseconds, or -1 for no timeout.
`String` | `getManagedRuntime()` The plugin string for the `ManagedRuntime` to use for managed environments.
`ManagedRuntime` | `getManagedRuntimeInstance()` The plugin to use for integrating with a managed runtime.
`String` | `getMapping()` The name mapping to use for this data store.
`int` | `getMaxFetchDepth()` The maximum relation depth to traverse when eager fetching.
`String` | `getMetaDataFactory()` A plugin string describing the `MetaDataFactory` to use.
`String` | `getMetaDataRepository()` A plugin string describing the `MetaDataRepository` to use.
`MetaDataRepository` | `getMetaDataRepositoryInstance()` The metadata repository of managed class information.
`boolean` | `getMultithreaded()` Whether brokers or their managed objects will be used by multiple concurrent threads.
`boolean` | `getNontransactionalRead()` Whether persistent state is accessible outside a transaction by default.
`boolean` | `getNontransactionalWrite()` Whether persistent state can be modified outside a transaction by default.
`boolean` | `getOptimistic()` Whether to use optimistic transactions by default.
`boolean` | `getOptimizeIdCopy()` Whether to attempt to optimize id class copy operations during the enhancement process.
`String` | `getOrphanedKeyAction()` The action to take when an orphaned key is detected.
`OrphanedKeyAction` | `getOrphanedKeyActionInstance()` The action to take when an orphaned key is detected.
`Map<String,Object>` | `getPersistenceEnvironment()`
`boolean` | `getPostLoadOnMerge()` Whether to send @PostLoad events on a merge operation.
`String` | `getProxyManager()` The plugin string for the `ProxyManager` to use for second class object proxies.
`ProxyManager` | `getProxyManagerInstance()` The `ProxyManager` to use.
`String` | `getQueryCache()` The plugin to use for level-2 data store query caching.
`String` | `getQueryCompilationCache()` Configuration settings for the query compilation cache to use.
`Map` | `getQueryCompilationCacheInstance()` Configuration settings for the query compilation cache to use.
`String` | `getQuerySQLCache()` Gets the configuration of QuerySQLCache.
`PreparedQueryCache` | `getQuerySQLCacheInstance()` Return PreparedQueryCache used for caching datastore queries.
`int` | `getQueryTimeout()` The time to wait for a query to execute in milliseconds, or -1 for no timeout.
`String` | `getReadLockLevel()` The default read lock level to use during non-optimistic transactions.
`int` | `getReadLockLevelConstant()` The numeric read lock level.
`boolean` | `getRefreshFromDataCache()` Gets whether entity state is to be refreshed from `DataCache`.
`RemoteCommitEventManager` | `getRemoteCommitEventManager()` The remote event manager that manages this configuration's remote event listeners.
`String` | `getRemoteCommitProvider()` The plugin to use for remote commit notification.
`String` | `getRestoreState()` Whether to restore initial state on rollback by default.
`int` | `getRestoreStateConstant()` Return the `RestoreState` constant.
`boolean` | `getRetainState()` Whether to retain state after a transaction by default.
`boolean` | `getRetryClassRegistration()` Whether to warn and defer registration instead of throwing an exception when a registered persistent class cannot be processed.
`String` | `getRuntimeUnenhancedClasses()` Specifies how OpenJPA handles unenhanced types.
`int` | `getRuntimeUnenhancedClassesConstant()` Return the runtime class optimization setting as one of the following symbolic constants: `RuntimeUnenhancedClassesModes.SUPPORTED` `RuntimeUnenhancedClassesModes.UNSUPPORTED` `RuntimeUnenhancedClassesModes.WARN`
`String` | `getSavepointManager()` The plugin to use for savepoint management.
`SavepointManager` | `getSavepointManagerInstance()` Return the configured savepoint manager instance.
`String` | `getSequence()` Plugin string for the default system `Seq`.
`Seq` | `getSequenceInstance()` The default system sequence.
`String` | `getSpecification()` Get the name of the Specification only (not the version or other information) or an empty String if not set.
`Specification` | `getSpecificationInstance()` Get the Specification.
`StoreFacadeTypeRegistry` | `getStoreFacadeTypeRegistry()` Return the `StoreFacadeTypeRegistry` instance associated with this configuration.
`String` | `getTransactionMode()` Specifies the behavior of the transaction model.
`Object` | `getValidationFactoryInstance()` The ValidatorFactory provided by the container or application.
`String` | `getValidationGroupPrePersist()` Gets the validation groups for pre-persist
`String` | `getValidationGroupPreRemove()` Gets the validation groups for pre-remove
`String` | `getValidationGroupPreUpdate()` Gets the validation groups for pre-update
`String` | `getValidationMode()` The bean validation mode to use for managed classes.
`Object` | `getValidatorInstance()` The Validator provided by the container or created by the runtime.
`String` | `getWriteLockLevel()` The default write lock level to use during non-optimistic transactions.
`int` | `getWriteLockLevelConstant()` The numeric write lock level.
`void` | `instantiateAll()` Call the instantiating get methods for all values.
`boolean` | `isConnectionFactoryModeManaged()` Whether connections are automatically enlisted in global transactions.
`boolean` | `isInitializeEagerly()` Affirms if all configured elements are initialized eagerly as opposed to lazily on-demand.
`boolean` | `isTransactionModeManaged()` Return whether managed transactions are being used.
`boolean` | `metaDataRepositoryAvailable()` Returns true if a metaDataRepository has been created for this configuration.
`BrokerImpl` | `newBrokerInstance(String user, String pass)` Create a new broker instance with the configured plugin data.
`InverseManager` | `newInverseManagerInstance()` Return a new inverse manager instance using the configured plugin settings.
`LockManager` | `newLockManagerInstance()` Return a new lock manager instance using the configured plugin settings.
`MetaDataFactory` | `newMetaDataFactoryInstance()` Create a new `MetaDataFactory` to use with a repository.
`MetaDataRepository` | `newMetaDataRepositoryInstance()` Create a new empty metadata repository of the configured type.
`RemoteCommitProvider` | `newRemoteCommitProviderInstance()` Create a remote commit provider from the configured plugin.
`protected void` | `preClose()` Invoked by final method `ConfigurationImpl.close()` after invoking the `ProductDerivation.beforeConfigurationClose(org.apache.openjpa.lib.conf.Configuration)` callbacks but before performing internal close operations.
`void` | `setAggregateListeners(AggregateListener[] listeners)` Set the query function listeners.
`void` | `setAggregateListeners(String aggregateListeners)` A comma-separted list of the plugin strings of the query `AggregateListener`s to use.
`void` | `setAuditor(String auditor)` Sets the plug-in string of `Auditor` specified in this configuration.
`void` | `setAuditorInstance(Auditor auditor)` Sets the singular instance of `Auditor` associated with this configuration.
`void` | `setAutoClear(int clear)` Whether instances clear their state when entering a transaction.
`void` | `setAutoClear(String clear)` Whether instances clear their state when entering a transaction.
`void` | `setAutoDetach(int autoDetachFlags)` The `AutoDetach` flags.
`void` | `setAutoDetach(String autoDetach)` A comma-separated list of events which trigger auto-detachment in place of managed states.
`void` | `setBrokerFactory(String factory)` The `BrokerFactory` class to use.
`void` | `setBrokerImpl(String broker)` The plugin string of the `BrokerImpl` extension to create.
`void` | `setCacheDistributionPolicy(String policyPlugin)` Sets the plug-in string that describes the policy to distribute cached instances across named partitions of L2 data cache.
`void` | `setCacheDistributionPolicyInstance(CacheDistributionPolicy policy)` Sets the policy object that determines distribution of cached instances across named partitions of L2 data cache.
`void` | `setCacheMarshallers(String marshallers)` A comma-separated list of the plugin strings specifying the `CacheMarshaller`s to use.
`void` | `setCallbackOptions(String options)` Options for configuring callbacks set as a comma-separated string value pair.
`void` | `setClassResolver(ClassResolver classResolver)` The `ClassResolver` to use.
`void` | `setClassResolver(String classResolver)` The plugin string for the `ClassResolver` to use for custom class loading.
`void` | `setCompatibility(String compatibility)` Backwards compatibility options.
`void` | `setConnection2DriverName(String driverName)` Class name of the non-XA connection driver.
`void` | `setConnection2Password(String connection2Password)` The password for the non-XA data store connection.
`void` | `setConnection2Properties(String connection2Properties)` These properties provide any additional information needed to establish non-XA connections.
`void` | `setConnection2URL(String connection2URL)` The URL for the non-XA data store connection.
`void` | `setConnection2UserName(String connection2UserName)` The user name for the non-XA data store connection.
`void` | `setConnectionDriverName(String driverName)` Class name of the connection driver.
`void` | `setConnectionFactory(Object factory)` The connection factory.
`void` | `setConnectionFactory2(Object factory)` The non-XA connection factory.
`void` | `setConnectionFactory2Name(String connectionFactory2Name)` The name for the second data store connection factory.
`void` | `setConnectionFactory2Properties(String connectionFactory2Properties)` Configuration properties for the non-XA connection factory.
`void` | `setConnectionFactoryMode(String mode)` The mode of the connection factory in use.
`void` | `setConnectionFactoryModeManaged(boolean managed)` Whether connections are automatically enlisted in global transactions.
`void` | `setConnectionFactoryName(String connectionFactoryName)` The name for the data store connection factory.
`void` | `setConnectionFactoryProperties(String connectionFactoryProperties)` Configuration properties for the connection factory.
`void` | `setConnectionPassword(String connectionPassword)` The password for the data store connection.
`void` | `setConnectionProperties(String connectionProperties)` These properties provide any additional information needed to establish connections.
`void` | `setConnectionRetainMode(int connectionRetainMode)` Set the connection retain mode as one of the following symbolic constants: `ConnectionRetainModes.CONN_RETAIN_ALWAYS` `ConnectionRetainModes.CONN_RETAIN_TRANS` `ConnectionRetainModes.CONN_RETAIN_DEMAND`
`void` | `setConnectionRetainMode(String connectionRetainMode)` Specifies the behavior of the broker with respect to data store connections.
`void` | `setConnectionURL(String connectionURL)` The URL for the data store connection.
`void` | `setConnectionUserName(String connectionUserName)` The user name for the data store connection.
`void` | `setDataCache(String dataCache)` The `DataCache` to use for level-2 data store caching.
`void` | `setDataCacheManager(DataCacheManager dcm)` The data cache manager manages this configuration's cache instances.
`void` | `setDataCacheManager(String mgr)` The data cache manager manages this configuration's cache instances.
`void` | `setDataCacheMode(String mode)` Set the `DataCacheMode`
`void` | `setDataCacheTimeout(int dataCacheTimeout)` Default data cache timeout.
`void` | `setDataCacheTimeout(Integer dataCacheTimeout)` Wrapper for JCA usage of `OpenJPAConfiguration.setDataCacheTimeout(int)`.
`void` | `setDetachState(DetachOptions detachState)` Return the instance specified by the detach state plugin.
`void` | `setDetachState(String detachState)` Which field values to include when detaching.
`void` | `setDynamicDataStructs(boolean dynamic)` Set whether to generate dynamic data structures where possible for cache and runtime usage.
`void` | `setDynamicDataStructs(Boolean dynamic)` Wrapper for JCA usage of `OpenJPAConfiguration.setDynamicDataStructs(boolean)`.
`void` | `setDynamicEnhancementAgent(boolean dynamic)` Sets whether OpenJPA will attempt to dynamically load the enhancement agent.
`void` | `setEncryptionProvider(String p)` Sets the `EncryptionProvider`.
`void` | `setFetchBatchSize(int fetchBatchSize)` Set the size of the batch that will be pre-selected when accessing elements in a query or relationship.
`void` | `setFetchBatchSize(Integer fetchBatchSize)` Wrapper for JCA usage of `OpenJPAConfiguration.setFetchBatchSize(int)`.
`void` | `setFetchGroups(String fetchGroups)` Comma-separated list of fetch group names that will be pre-set for all new `FetchConfiguration`s.
`void` | `setFetchGroups(String[] fetchGroups)` List of fetch group names that will be pre-set for all new `FetchConfiguration`s.
`void` | `setFilterListeners(FilterListener[] listeners)` Set the query filter listeners.
`void` | `setFilterListeners(String filterListeners)` A comma-separted list of the plugin strings of the query `FilterListener`s to use.
`void` | `setFinderCache(String finderCache)` Set the finder cache from a string configuration.
`void` | `setFlushBeforeQueries(int flush)` Set to one of `QueryFlushModes.FLUSH_TRUE`, `QueryFlushModes.FLUSH_FALSE`, or `QueryFlushModes.FLUSH_WITH_CONNECTION`.
`void` | `setFlushBeforeQueries(String flush)` Sets whether or not OpenJPA should automatically flush modifications to the data store before executing queries.
`void` | `setIgnoreChanges(boolean ignoreChanges)` Whether changes in the current transaction are taken into account when executing queries and iterating extents.
`void` | `setIgnoreChanges(Boolean ignoreChanges)` Wrapper for JCA usage of `OpenJPAConfiguration.setIgnoreChanges(boolean)`.
`void` | `setInitializeEagerly(boolean retry)` Sets whether all configured elements will be initialized eagerly or lazily on-demand.
`void` | `setInstrumentation(String providers)` Sets the plug-in string that defines instrumentation providers and what they instrument.
`void` | `setInstrumentationManager(InstrumentationManager im)`
`void` | `setInstrumentationManager(String mgr)`
`void` | `setInverseManager(String inverseManager)` The plugin to use for managing inverse relations.
`void` | `setLifecycleEventManager(String lem)` Sets the lifecycle event manager instance classname.
`void` | `setLockManager(String lockManager)` The plugin to use for datastore lock management.
`void` | `setLockTimeout(int timeout)` The time to wait for an object lock in milliseconds, or -1 for no timeout.
`void` | `setLockTimeout(Integer timeout)` Wrapper for JCA usage of `OpenJPAConfiguration.setLockTimeout(int)`.
`void` | `setManagedRuntime(ManagedRuntime managedRuntime)` The plugin to use for integrating with a managed runtime.
`void` | `setManagedRuntime(String managedRuntime)` The plugin string for the `ManagedRuntime` to use for managed environments.
`void` | `setMapping(String mapping)` The name mapping to use for this data store.
`void` | `setMaxFetchDepth(int maxFetchDepth)` The maximum relation depth to traverse when eager fetching.
`void` | `setMaxFetchDepth(Integer maxFetchDepth)` Wrapper for JCA usage of `OpenJPAConfiguration.setMaxFetchDepth(int)`.
`void` | `setMetaDataFactory(String meta)` A plugin string describing the `MetaDataFactory` to use.
`void` | `setMetaDataRepository(MetaDataRepository meta)` The metadata repository of managed class information.
`void` | `setMetaDataRepository(String meta)` A plugin string describing the `MetaDataRepository` to use.
`void` | `setMultithreaded(boolean multithreaded)` Whether brokers or their managed objects will be used by multiple concurrent threads.
`void` | `setMultithreaded(Boolean multithreaded)` Wrapper for JCA usage of `OpenJPAConfiguration.setMultithreaded(boolean)`.
`void` | `setNontransactionalRead(boolean nontransactionalRead)` Whether persistent state is accessible outside a transaction by default.
`void` | `setNontransactionalRead(Boolean nontransactionalRead)` Wrapper for JCA usage of `OpenJPAConfiguration.setNontransactionalRead(boolean)`.
`void` | `setNontransactionalWrite(boolean nontransactionalWrite)` Whether persistent state can be modified outside a transaction by default.
`void` | `setNontransactionalWrite(Boolean nontransactionalWrite)` Wrapper for JCA usage of `OpenJPAConfiguration.setNontransactionalWrite(boolean)`.
`void` | `setOptimistic(boolean optimistic)` Whether to use optimistic transactions by default.
`void` | `setOptimistic(Boolean optimistic)` Wrapper for JCA usage of `OpenJPAConfiguration.setOptimistic(boolean)`.
`void` | `setOptimizeIdCopy(boolean optimizeId)` Whether to attempt to optimize id class copy operations during the enhancement process.
`void` | `setOptimizeIdCopy(Boolean optimizeId)` Whether to attempt to optimize id class copy operations during the enhancement process.
`void` | `setOrphanedKeyAction(OrphanedKeyAction action)` The action to take when an orphaned key is detected.
`void` | `setOrphanedKeyAction(String action)` The action to take when an orphaned key is detected.
`void` | `setPersistenceEnvironment(Map<String,Object> peMap)`
`void` | `setPostLoadOnMerge(boolean postLoadOnMerge)` Whether to send @PostLoad events on a merge operation.
`void` | `setPostLoadOnMerge(Boolean postLoadOnMerge)` Whether to send @PostLoad events on a merge operation.
`void` | `setProxyManager(ProxyManager proxyManager)` The `ProxyManager` to use.
`void` | `setProxyManager(String proxyManager)` The plugin string for the `ProxyManager` to use for second class object proxies.
`void` | `setQueryCache(String queryCache)` The plugin to use for level-2 data store query caching.
`void` | `setQueryCompilationCache(String queryCompilationCache)` Configuration settings for the query compilation cache to use.
`void` | `setQuerySQLCache(PreparedQueryCache querySQLCache)` Sets QuerySQLCache with the given cache.
`void` | `setQuerySQLCache(String querySQLCache)` Sets QuerySQLCache with the given configuration.
`void` | `setQueryTimeout(int timeout)` The time to wait for a query to execute in milliseconds, or -1 for no timeout.
`void` | `setReadLockLevel(int level)` The numeric read lock level.
`void` | `setReadLockLevel(String level)` The default read lock level to use during non-optimistic transactions.
`void` | `setRefreshFromDataCache(boolean flag)` Sets whether entity state is to be refreshed from `DataCache`.
`void` | `setRefreshFromDataCache(Boolean flag)` Sets whether entity state is to be refreshed from `DataCache`.
`void` | `setRemoteCommitEventManager(RemoteCommitEventManager remoteEventManager)` The remote event manager that manages this configuration's remote event listeners.
`void` | `setRemoteCommitProvider(String remoteCommitProvider)` The plugin to use for remote commit notification.
`void` | `setRestoreState(int restoreState)` Whether to restore initial state on rollback by default.
`void` | `setRestoreState(String restoreState)` Whether to restore initial state on rollback by default.
`void` | `setRetainState(boolean retainState)` Whether to retain state after a transaction by default.
`void` | `setRetainState(Boolean retainState)` Wrapper for JCA usage of `OpenJPAConfiguration.setRetainState(boolean)`.
`void` | `setRetryClassRegistration(boolean retry)` Whether to warn and defer registration instead of throwing an exception when a registered persistent class cannot be processed.
`void` | `setRetryClassRegistration(Boolean retry)` Wrapper for JCA usage of `OpenJPAConfiguration.setRetryClassRegistration(boolean)`.
`void` | `setRuntimeUnenhancedClasses(int mode)` Set the runtime class optimization setting as one of the following symbolic constants: `RuntimeUnenhancedClassesModes.SUPPORTED` `RuntimeUnenhancedClassesModes.UNSUPPORTED` `RuntimeUnenhancedClassesModes.WARN`
`void` | `setRuntimeUnenhancedClasses(String mode)` Specifies how OpenJPA handles unenhanced types.
`void` | `setSavepointManager(String savepointManager)` The plugin to use for savepoint management.
`void` | `setSequence(Seq seq)` The default system sequence.
`void` | `setSequence(String sequence)` Plugin string for the default system `Seq`.
`void` | `setSpecification(Specification newSpec)` Set the Specification for this configuration.
`void` | `setSpecification(String spec)` Sets Specification from the given String.
`void` | `setTransactionMode(String transactionMode)` Specifies the behavior of the transaction model.
`void` | `setTransactionModeManaged(boolean managed)` Set whether managed transactions are being used.
`void` | `setValidationFactory(Object factory)` Set the container or application provided ValidatorFactory instance.
`void` | `setValidationGroupPrePersist(String vgPrePersist)` Sets the validation groups for pre-persist
`void` | `setValidationGroupPreRemove(String vgPreRemove)` Sets the validation groups for pre-remove
`void` | `setValidationGroupPreUpdate(String vgPreUpdate)` Sets the validation groups for pre-update
`void` | `setValidationMode(String mode)` Set the bean validation mode to use for managed classes.
`void` | `setValidatorInstance(Object val)` Set the container or application provided Validator instance.
`void` | `setWriteLockLevel(int level)` The numeric write lock level.
`void` | `setWriteLockLevel(String level)` The default write lock level to use during non-optimistic transactions.
`Collection<String>` | `supportedOptions()` Return the set of option strings supported by this runtime.

Methods inherited from class org.apache.openjpa.lib.conf.ConfigurationImpl
`addBoolean, addDouble, addFile, addInt, addObject, addPlugin, addPluginList, addPropertyChangeListener, addString, addStringList, addValue, clone, close, equals, fromProperties, getAdditionalBeanInfo, getBeanDescriptor, getDefaultEventIndex, getDefaultPropertyIndex, getEventSetDescriptors, getIcon, getId, getLog, getLog, getLogFactory, getMethodDescriptors, getProductName, getPropertiesResource, getPropertyDescriptors, getPropertyKeys, getPropertyKeys, getValue, getValues, hashCode, isDeferResourceLoading, isInvalidProperty, isReadOnly, loadGlobals, readExternal, removePropertyChangeListener, removeValue, setDeferResourceLoading, setId, setLog, setLogFactory, setProductName, setProperties, setPropertiesFile, setReadOnly, toProperties, toXMLName, valueChanged, writeExternal`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.openjpa.lib.conf.Configuration
`addPropertyChangeListener, addValue, clone, close, fromProperties, getId, getLog, getLog, getLogFactory, getProductName, getPropertyKeys, getPropertyKeys, getValue, getValues, isReadOnly, removePropertyChangeListener, removeValue, setId, setLog, setLogFactory, setProductName, setReadOnly, toProperties`

Methods inherited from interface java.beans.BeanInfo
`getAdditionalBeanInfo, getBeanDescriptor, getDefaultEventIndex, getDefaultPropertyIndex, getEventSetDescriptors, getIcon, getMethodDescriptors, getPropertyDescriptors`

Field Detail

### metaRepository

    protected MetaDataRepository metaRepository

### remoteEventManager

    protected RemoteCommitEventManager remoteEventManager

### classResolverPlugin

    public ObjectValue classResolverPlugin

### brokerPlugin

    public BrokerValue brokerPlugin

### dataCachePlugin

    public ObjectValue dataCachePlugin

### dataCacheManagerPlugin

    public ObjectValue dataCacheManagerPlugin

### auditorPlugin

    public ObjectValue auditorPlugin

### cacheDistributionPolicyPlugin

    public ObjectValue cacheDistributionPolicyPlugin

### dataCacheTimeout

    public IntValue dataCacheTimeout

### queryCachePlugin

    public ObjectValue queryCachePlugin

### dynamicDataStructs

    public BooleanValue dynamicDataStructs

### managedRuntimePlugin

    public ObjectValue managedRuntimePlugin

### transactionMode

    public BooleanValue transactionMode

### connectionRetainMode

    public IntValue connectionRetainMode

### fetchBatchSize

    public IntValue fetchBatchSize

### maxFetchDepth

    public IntValue maxFetchDepth

### fetchGroups

    public StringListValue fetchGroups

### flushBeforeQueries

    public IntValue flushBeforeQueries

### lockTimeout

    public IntValue lockTimeout

### queryTimeout

    public IntValue queryTimeout

### readLockLevel

    public IntValue readLockLevel

### writeLockLevel

    public IntValue writeLockLevel

### seqPlugin

    public ObjectValue seqPlugin

### filterListenerPlugins

    public PluginListValue filterListenerPlugins

### aggregateListenerPlugins

    public PluginListValue aggregateListenerPlugins

### retryClassRegistration

    public BooleanValue retryClassRegistration

### proxyManagerPlugin

    public ObjectValue proxyManagerPlugin

### connectionUserName

    public StringValue connectionUserName

### connectionPassword

    public StringValue connectionPassword

### encryptionProvider

    public PluginValue encryptionProvider

### connectionURL

    public StringValue connectionURL

### connectionDriverName

    public StringValue connectionDriverName

### connectionFactory

    public ObjectValue connectionFactory

### connectionFactoryName

    public StringValue connectionFactoryName

### connectionProperties

    public StringValue connectionProperties

### connectionFactoryProperties

    public StringValue connectionFactoryProperties

### connectionFactoryMode

    public BooleanValue connectionFactoryMode

### connection2UserName

    public StringValue connection2UserName

### connection2Password

    public StringValue connection2Password

### connection2URL

    public StringValue connection2URL

### connection2DriverName

    public StringValue connection2DriverName

### connection2Properties

    public StringValue connection2Properties

### connectionFactory2

    public ObjectValue connectionFactory2

### connectionFactory2Name

    public StringValue connectionFactory2Name

### connectionFactory2Properties

    public StringValue connectionFactory2Properties

### optimistic

    public BooleanValue optimistic

### autoClear

    public IntValue autoClear

### retainState

    public BooleanValue retainState

### restoreState

    public IntValue restoreState

### detachStatePlugin

    public ObjectValue detachStatePlugin

### ignoreChanges

    public BooleanValue ignoreChanges

### nontransactionalRead

    public BooleanValue nontransactionalRead

### nontransactionalWrite

    public BooleanValue nontransactionalWrite

### refreshFromDataCache

    public BooleanValue refreshFromDataCache

### multithreaded

    public BooleanValue multithreaded

### mapping

    public StringValue mapping

### metaFactoryPlugin

    public PluginValue metaFactoryPlugin

### metaRepositoryPlugin

    public MetaDataRepositoryValue metaRepositoryPlugin

### lockManagerPlugin

    public ObjectValue lockManagerPlugin

### inverseManagerPlugin

    public ObjectValue inverseManagerPlugin

### savepointManagerPlugin

    public ObjectValue savepointManagerPlugin

### orphanedKeyPlugin

    public ObjectValue orphanedKeyPlugin

### compatibilityPlugin

    public ObjectValue compatibilityPlugin

### callbackPlugin

    public ObjectValue callbackPlugin

### queryCompilationCachePlugin

    public QueryCompilationCacheValue queryCompilationCachePlugin

### runtimeUnenhancedClasses

    public IntValue runtimeUnenhancedClasses

### cacheMarshallerPlugins

    public CacheMarshallersValue cacheMarshallerPlugins

### eagerInitialization

    public BooleanValue eagerInitialization

### preparedQueryCachePlugin

    public PluginValue preparedQueryCachePlugin

### finderCachePlugin

    public PluginValue finderCachePlugin

### specification

    public ObjectValue specification

### validationMode

    public StringValue validationMode

### validationFactory

    public ObjectValue validationFactory

### validator

    public ObjectValue validator

### lifecycleEventManager

    public ObjectValue lifecycleEventManager

### validationGroupPrePersist

    public StringValue validationGroupPrePersist

### validationGroupPreUpdate

    public StringValue validationGroupPreUpdate

### validationGroupPreRemove

    public StringValue validationGroupPreRemove

### dataCacheMode

    public StringValue dataCacheMode

### dynamicEnhancementAgent

    public BooleanValue dynamicEnhancementAgent

### instrumentationManager

    public ObjectValue instrumentationManager

### instrumentationProviders

    public PluginListValue instrumentationProviders

### postLoadOnMerge

    public BooleanValue postLoadOnMerge

### optimizeIdCopy

    public BooleanValue optimizeIdCopy

### brokerFactoryPlugin

    public BrokerFactoryValue brokerFactoryPlugin

### remoteProviderPlugin

    public RemoteCommitProviderValue remoteProviderPlugin

### autoDetach

    public AutoDetachValue autoDetach

Constructor Detail

### OpenJPAConfigurationImpl

    public OpenJPAConfigurationImpl()

  Default constructor. Attempts to load global properties.

### OpenJPAConfigurationImpl

    public OpenJPAConfigurationImpl(boolean loadGlobals)

  Constructor.

  Parameters:
    `loadGlobals` - whether to attempt to load the global properties

### OpenJPAConfigurationImpl

    public OpenJPAConfigurationImpl(boolean derivations,
                                    boolean loadGlobals)

  Constructor.

  Parameters:
    `derivations` - whether to apply product derivations
    `loadGlobals` - whether to attempt to load the global properties

Method Detail

### supportedOptions

    public Collection<String> supportedOptions()

  Description copied from interface: `OpenJPAConfiguration`
  Return the set of option strings supported by this runtime. This set is mutable.

  Specified by:
    `supportedOptions` in interface `OpenJPAConfiguration`

### getSpecification

    public String getSpecification()

  Get the name of the Specification only (not the version or other information) or an empty String if not set.

  Specified by:
    `getSpecification` in interface `OpenJPAConfiguration`

### getSpecificationInstance

    public Specification getSpecificationInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Get the Specification. Specification determines various important default behaviors.

  Specified by:
    `getSpecificationInstance` in interface `OpenJPAConfiguration`

### setSpecification

    public void setSpecification(String spec)

  Sets Specification from the given String.

  Specified by:
    `setSpecification` in interface `OpenJPAConfiguration`
  Parameters:
    `spec` - should be encoded in the format specified in `Specification`.
  See Also:
    `Specification`

### setSpecification

    public void setSpecification(Specification newSpec)

  Description copied from interface: `OpenJPAConfiguration`
  Set the Specification for this configuration. Specification determines various default properties and behavior. For example, `compatibility` options during runtime. This change will trigger all registered Product Derivations to mutate other configuration properties.

  Specified by:
    `setSpecification` in interface `OpenJPAConfiguration`
  Parameters:
    `newSpec` - fullname of the specification that possibly encodes major and minor version information. For encoding format
  See Also:
    `Specification`

### setClassResolver

    public void setClassResolver(String classResolver)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string for the `ClassResolver` to use for custom class loading.

  Specified by:
    `setClassResolver` in interface `OpenJPAConfiguration`

### getClassResolver

    public String getClassResolver()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string for the `ClassResolver` to use for custom class loading.

  Specified by:
    `getClassResolver` in interface `OpenJPAConfiguration`

### setClassResolver

    public void setClassResolver(ClassResolver classResolver)

  Description copied from interface: `OpenJPAConfiguration`
  The `ClassResolver` to use.

  Specified by:
    `setClassResolver` in interface `OpenJPAConfiguration`

### getClassResolverInstance

    public ClassResolver getClassResolverInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The `ClassResolver` to use.

  Specified by:
    `getClassResolverInstance` in interface `OpenJPAConfiguration`

### setBrokerFactory

    public void setBrokerFactory(String factory)

  Description copied from interface: `OpenJPAConfiguration`
  The `BrokerFactory` class to use.

  Specified by:
    `setBrokerFactory` in interface `OpenJPAConfiguration`

### getBrokerFactory

    public String getBrokerFactory()

  Description copied from interface: `OpenJPAConfiguration`
  The `BrokerFactory` class to use.

  Specified by:
    `getBrokerFactory` in interface `OpenJPAConfiguration`

### setBrokerImpl

    public void setBrokerImpl(String broker)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string of the `BrokerImpl` extension to create.

  Specified by:
    `setBrokerImpl` in interface `OpenJPAConfiguration`

### getBrokerImpl

    public String getBrokerImpl()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string of the `BrokerImpl` extension to create.

  Specified by:
    `getBrokerImpl` in interface `OpenJPAConfiguration`

### newBrokerInstance

    public BrokerImpl newBrokerInstance(String user,
                                        String pass)

  Description copied from interface: `OpenJPAConfiguration`
  Create a new broker instance with the configured plugin data.

  Specified by:
    `newBrokerInstance` in interface `OpenJPAConfiguration`

### setDataCacheManager

    public void setDataCacheManager(String mgr)

  Description copied from interface: `OpenJPAConfiguration`
  The data cache manager manages this configuration's cache instances.

  Specified by:
    `setDataCacheManager` in interface `OpenJPAConfiguration`

### getDataCacheManager

    public String getDataCacheManager()

  Description copied from interface: `OpenJPAConfiguration`
  The data cache manager manages this configuration's cache instances.

  Specified by:
    `getDataCacheManager` in interface `OpenJPAConfiguration`

### setDataCacheManager

    public void setDataCacheManager(DataCacheManager dcm)

  Description copied from interface: `OpenJPAConfiguration`
  The data cache manager manages this configuration's cache instances.

  Specified by:
    `setDataCacheManager` in interface `OpenJPAConfiguration`

### getDataCacheManagerInstance

    public DataCacheManager getDataCacheManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The data cache manager manages this configuration's cache instances. The cache manager is created if it has not been set. Once the cache manager has been set/created, all changes to caching configuration must proceed through the cache manager.

  Specified by:
    `getDataCacheManagerInstance` in interface `OpenJPAConfiguration`

### setDataCache

    public void setDataCache(String dataCache)

  Description copied from interface: `OpenJPAConfiguration`
  The `DataCache` to use for level-2 data store caching.

  Specified by:
    `setDataCache` in interface `OpenJPAConfiguration`

### getDataCache

    public String getDataCache()

  Description copied from interface: `OpenJPAConfiguration`
  The `DataCache` to use for level-2 data store caching.

  Specified by:
    `getDataCache` in interface `OpenJPAConfiguration`

### setDataCacheTimeout

    public void setDataCacheTimeout(int dataCacheTimeout)

  Description copied from interface: `OpenJPAConfiguration`
  Default data cache timeout.

  Specified by:
    `setDataCacheTimeout` in interface `OpenJPAConfiguration`

### setDataCacheTimeout

    public void setDataCacheTimeout(Integer dataCacheTimeout)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setDataCacheTimeout(int)`.

  Specified by:
    `setDataCacheTimeout` in interface `OpenJPAConfiguration`

### getDataCacheTimeout

    public int getDataCacheTimeout()

  Description copied from interface: `OpenJPAConfiguration`
  Default data cache timeout.

  Specified by:
    `getDataCacheTimeout` in interface `OpenJPAConfiguration`

### setQueryCache

    public void setQueryCache(String queryCache)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for level-2 data store query caching.

  Specified by:
    `setQueryCache` in interface `OpenJPAConfiguration`

### getQueryCache

    public String getQueryCache()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for level-2 data store query caching.

  Specified by:
    `getQueryCache` in interface `OpenJPAConfiguration`

### getRefreshFromDataCache

    public boolean getRefreshFromDataCache()

  Description copied from interface: `OpenJPAConfiguration`
  Gets whether entity state is to be refreshed from `DataCache`. The entities are never refreshed from DataCache if lock is being applied (e.g. in a pessimistic transaction) and hence this setting only refers to behavior when not locking. This flag can be used to overwrite RetrieveMode.BYPASS. By default, however, this falg is false.

  Specified by:
    `getRefreshFromDataCache` in interface `OpenJPAConfiguration`

### setRefreshFromDataCache

    public void setRefreshFromDataCache(boolean flag)

  Description copied from interface: `OpenJPAConfiguration`
  Sets whether entity state is to be refreshed from `DataCache`. The entities are never refreshed from DataCache if lock is being applied (e.g. in a pessimistic transaction) and hence this setting only refers to behavior when not locking.

  Specified by:
    `setRefreshFromDataCache` in interface `OpenJPAConfiguration`

### setRefreshFromDataCache

    public void setRefreshFromDataCache(Boolean flag)

  Description copied from interface: `OpenJPAConfiguration`
  Sets whether entity state is to be refreshed from `DataCache`. The entities are never refreshed from DataCache if lock is being applied (e.g. in a pessimistic transaction) and hence this setting only refers to behavior when not locking.

  Specified by:
    `setRefreshFromDataCache` in interface `OpenJPAConfiguration`

### getDynamicDataStructs

    public boolean getDynamicDataStructs()

  Description copied from interface: `OpenJPAConfiguration`
  Return whether to generate dynamic data structures where possible for cache and runtime usage.

  Specified by:
    `getDynamicDataStructs` in interface `OpenJPAConfiguration`

### setDynamicDataStructs

    public void setDynamicDataStructs(boolean dynamic)

  Description copied from interface: `OpenJPAConfiguration`
  Set whether to generate dynamic data structures where possible for cache and runtime usage.

  Specified by:
    `setDynamicDataStructs` in interface `OpenJPAConfiguration`

### setDynamicDataStructs

    public void setDynamicDataStructs(Boolean dynamic)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setDynamicDataStructs(boolean)`.

  Specified by:
    `setDynamicDataStructs` in interface `OpenJPAConfiguration`

### setLockManager

    public void setLockManager(String lockManager)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for datastore lock management.

  Specified by:
    `setLockManager` in interface `OpenJPAConfiguration`

### getLockManager

    public String getLockManager()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for datastore lock management.

  Specified by:
    `getLockManager` in interface `OpenJPAConfiguration`

### newLockManagerInstance

    public LockManager newLockManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Return a new lock manager instance using the configured plugin settings.

  Specified by:
    `newLockManagerInstance` in interface `OpenJPAConfiguration`

### setInverseManager

    public void setInverseManager(String inverseManager)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for managing inverse relations.

  Specified by:
    `setInverseManager` in interface `OpenJPAConfiguration`

### getInverseManager

    public String getInverseManager()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for managing inverse relations.

  Specified by:
    `getInverseManager` in interface `OpenJPAConfiguration`

### newInverseManagerInstance

    public InverseManager newInverseManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Return a new inverse manager instance using the configured plugin settings.

  Specified by:
    `newInverseManagerInstance` in interface `OpenJPAConfiguration`

### setSavepointManager

    public void setSavepointManager(String savepointManager)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for savepoint management.

  Specified by:
    `setSavepointManager` in interface `OpenJPAConfiguration`

### getSavepointManager

    public String getSavepointManager()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for savepoint management.

  Specified by:
    `getSavepointManager` in interface `OpenJPAConfiguration`

### getSavepointManagerInstance

    public SavepointManager getSavepointManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Return the configured savepoint manager instance.

  Specified by:
    `getSavepointManagerInstance` in interface `OpenJPAConfiguration`

### setOrphanedKeyAction

    public void setOrphanedKeyAction(String action)

  Description copied from interface: `OpenJPAConfiguration`
  The action to take when an orphaned key is detected.

  Specified by:
    `setOrphanedKeyAction` in interface `OpenJPAConfiguration`

### getOrphanedKeyAction

    public String getOrphanedKeyAction()

  Description copied from interface: `OpenJPAConfiguration`
  The action to take when an orphaned key is detected.

  Specified by:
    `getOrphanedKeyAction` in interface `OpenJPAConfiguration`

### getOrphanedKeyActionInstance

    public OrphanedKeyAction getOrphanedKeyActionInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The action to take when an orphaned key is detected.

  Specified by:
    `getOrphanedKeyActionInstance` in interface `OpenJPAConfiguration`

### setOrphanedKeyAction

    public void setOrphanedKeyAction(OrphanedKeyAction action)

  Description copied from interface: `OpenJPAConfiguration`
  The action to take when an orphaned key is detected.

  Specified by:
    `setOrphanedKeyAction` in interface `OpenJPAConfiguration`

### setRemoteCommitProvider

    public void setRemoteCommitProvider(String remoteCommitProvider)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for remote commit notification.

  Specified by:
    `setRemoteCommitProvider` in interface `OpenJPAConfiguration`

### getRemoteCommitProvider

    public String getRemoteCommitProvider()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for remote commit notification.

  Specified by:
    `getRemoteCommitProvider` in interface `OpenJPAConfiguration`

### newRemoteCommitProviderInstance

    public RemoteCommitProvider newRemoteCommitProviderInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Create a remote commit provider from the configured plugin.

  Specified by:
    `newRemoteCommitProviderInstance` in interface `OpenJPAConfiguration`

### setRemoteCommitEventManager

    public void setRemoteCommitEventManager(RemoteCommitEventManager remoteEventManager)

  Description copied from interface: `OpenJPAConfiguration`
  The remote event manager that manages this configuration's remote event listeners.

  Specified by:
    `setRemoteCommitEventManager` in interface `OpenJPAConfiguration`

### getRemoteCommitEventManager

    public RemoteCommitEventManager getRemoteCommitEventManager()

  Description copied from interface: `OpenJPAConfiguration`
  The remote event manager that manages this configuration's remote event listeners.

  Specified by:
    `getRemoteCommitEventManager` in interface `OpenJPAConfiguration`

### setTransactionMode

    public void setTransactionMode(String transactionMode)

  Description copied from interface: `OpenJPAConfiguration`
  Specifies the behavior of the transaction model. Possible values are:
  - `local`: Perform transaction operations locally.
  - `managed`: Use managed environment's global transactions.

  Specified by:
    `setTransactionMode` in interface `OpenJPAConfiguration`

### getTransactionMode

    public String getTransactionMode()

  Description copied from interface: `OpenJPAConfiguration`
  Specifies the behavior of the transaction model. Possible values are:
  - `local`: Perform transaction operations locally.
  - `managed`: Use managed environment's global transactions.

  Specified by:
    `getTransactionMode` in interface `OpenJPAConfiguration`

### setTransactionModeManaged

    public void setTransactionModeManaged(boolean managed)

  Description copied from interface: `OpenJPAConfiguration`
  Set whether managed transactions are being used.

  Specified by:
    `setTransactionModeManaged` in interface `OpenJPAConfiguration`

### isTransactionModeManaged

    public boolean isTransactionModeManaged()

  Description copied from interface: `OpenJPAConfiguration`
  Return whether managed transactions are being used.

  Specified by:
    `isTransactionModeManaged` in interface `OpenJPAConfiguration`

### setManagedRuntime

    public void setManagedRuntime(String managedRuntime)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string for the `ManagedRuntime` to use for managed environments.

  Specified by:
    `setManagedRuntime` in interface `OpenJPAConfiguration`

### getManagedRuntime

    public String getManagedRuntime()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string for the `ManagedRuntime` to use for managed environments.

  Specified by:
    `getManagedRuntime` in interface `OpenJPAConfiguration`

### setManagedRuntime

    public void setManagedRuntime(ManagedRuntime managedRuntime)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for integrating with a managed runtime.

  Specified by:
    `setManagedRuntime` in interface `OpenJPAConfiguration`

### getManagedRuntimeInstance

    public ManagedRuntime getManagedRuntimeInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin to use for integrating with a managed runtime.

  Specified by:
    `getManagedRuntimeInstance` in interface `OpenJPAConfiguration`

### setProxyManager

    public void setProxyManager(String proxyManager)

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string for the `ProxyManager` to use for second class object proxies.

  Specified by:
    `setProxyManager` in interface `OpenJPAConfiguration`

### getProxyManager

    public String getProxyManager()

  Description copied from interface: `OpenJPAConfiguration`
  The plugin string for the `ProxyManager` to use for second class object proxies.

  Specified by:
    `getProxyManager` in interface `OpenJPAConfiguration`

### setProxyManager

    public void setProxyManager(ProxyManager proxyManager)

  Description copied from interface: `OpenJPAConfiguration`
  The `ProxyManager` to use.

  Specified by:
    `setProxyManager` in interface `OpenJPAConfiguration`

### getProxyManagerInstance

    public ProxyManager getProxyManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The `ProxyManager` to use.

  Specified by:
    `getProxyManagerInstance` in interface `OpenJPAConfiguration`

### setMapping

    public void setMapping(String mapping)

  Description copied from interface: `OpenJPAConfiguration`
  The name mapping to use for this data store.

  Specified by:
    `setMapping` in interface `OpenJPAConfiguration`

### getMapping

    public String getMapping()

  Description copied from interface: `OpenJPAConfiguration`
  The name mapping to use for this data store.

  Specified by:
    `getMapping` in interface `OpenJPAConfiguration`

### setMetaDataFactory

    public void setMetaDataFactory(String meta)

  Description copied from interface: `OpenJPAConfiguration`
  A plugin string describing the `MetaDataFactory` to use.

  Specified by:
    `setMetaDataFactory` in interface `OpenJPAConfiguration`

### getMetaDataFactory

    public String getMetaDataFactory()

  Description copied from interface: `OpenJPAConfiguration`
  A plugin string describing the `MetaDataFactory` to use.

  Specified by:
    `getMetaDataFactory` in interface `OpenJPAConfiguration`

### newMetaDataFactoryInstance

    public MetaDataFactory newMetaDataFactoryInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Create a new `MetaDataFactory` to use with a repository.

  Specified by:
    `newMetaDataFactoryInstance` in interface `OpenJPAConfiguration`

### setMetaDataRepository

    public void setMetaDataRepository(String meta)

  Description copied from interface: `OpenJPAConfiguration`
  A plugin string describing the `MetaDataRepository` to use.

  Specified by:
    `setMetaDataRepository` in interface `OpenJPAConfiguration`

### getMetaDataRepository

    public String getMetaDataRepository()

  Description copied from interface: `OpenJPAConfiguration`
  A plugin string describing the `MetaDataRepository` to use.

  Specified by:
    `getMetaDataRepository` in interface `OpenJPAConfiguration`

### setMetaDataRepository

    public void setMetaDataRepository(MetaDataRepository meta)

  Description copied from interface: `OpenJPAConfiguration`
  The metadata repository of managed class information.

  Specified by:
    `setMetaDataRepository` in interface `OpenJPAConfiguration`

### getMetaDataRepositoryInstance

    public MetaDataRepository getMetaDataRepositoryInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The metadata repository of managed class information. If no repository has been set, creates one.

  Specified by:
    `getMetaDataRepositoryInstance` in interface `OpenJPAConfiguration`

### metaDataRepositoryAvailable

    public boolean metaDataRepositoryAvailable()

  Description copied from interface: `OpenJPAConfiguration`
  Returns true if a metaDataRepository has been created for this configuration.

  Specified by:
    `metaDataRepositoryAvailable` in interface `OpenJPAConfiguration`

### newMetaDataRepositoryInstance

    public MetaDataRepository newMetaDataRepositoryInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Create a new empty metadata repository of the configured type.

  Specified by:
    `newMetaDataRepositoryInstance` in interface `OpenJPAConfiguration`

### setConnectionUserName

    public void setConnectionUserName(String connectionUserName)

  Description copied from interface: `OpenJPAConfiguration`
  The user name for the data store connection.

  Specified by:
    `setConnectionUserName` in interface `OpenJPAConfiguration`

### getConnectionUserName

    public String getConnectionUserName()

  Description copied from interface: `OpenJPAConfiguration`
  The user name for the data store connection.

  Specified by:
    `getConnectionUserName` in interface `OpenJPAConfiguration`

### setConnectionPassword

    public void setConnectionPassword(String connectionPassword)

  Description copied from interface: `OpenJPAConfiguration`
  The password for the data store connection.

  Specified by:
    `setConnectionPassword` in interface `OpenJPAConfiguration`

### getConnectionPassword

    public String getConnectionPassword()

  Description copied from interface: `OpenJPAConfiguration`
  The password for the data store connection.

  Specified by:
    `getConnectionPassword` in interface `OpenJPAConfiguration`

### setConnectionURL

    public void setConnectionURL(String connectionURL)

  Description copied from interface: `OpenJPAConfiguration`
  The URL for the data store connection.

  Specified by:
    `setConnectionURL` in interface `OpenJPAConfiguration`

### getConnectionURL

    public String getConnectionURL()

  Description copied from interface: `OpenJPAConfiguration`
  The URL for the data store connection.

  Specified by:
    `getConnectionURL` in interface `OpenJPAConfiguration`

### setConnectionDriverName

    public void setConnectionDriverName(String driverName)

  Description copied from interface: `OpenJPAConfiguration`
  Class name of the connection driver.

  Specified by:
    `setConnectionDriverName` in interface `OpenJPAConfiguration`

### getConnectionDriverName

    public String getConnectionDriverName()

  Description copied from interface: `OpenJPAConfiguration`
  Class name of the connection driver.

  Specified by:
    `getConnectionDriverName` in interface `OpenJPAConfiguration`

### setConnectionProperties

    public void setConnectionProperties(String connectionProperties)

  Description copied from interface: `OpenJPAConfiguration`
  These properties provide any additional information needed to establish connections.

  Specified by:
    `setConnectionProperties` in interface `OpenJPAConfiguration`

### getConnectionProperties

    public String getConnectionProperties()

  Description copied from interface: `OpenJPAConfiguration`
  These properties provide any additional information needed to establish connections.

  Specified by:
    `getConnectionProperties` in interface `OpenJPAConfiguration`

### setConnectionFactoryProperties

    public void setConnectionFactoryProperties(String connectionFactoryProperties)

  Description copied from interface: `OpenJPAConfiguration`
  Configuration properties for the connection factory.

  Specified by:
    `setConnectionFactoryProperties` in interface `OpenJPAConfiguration`

### getConnectionFactoryProperties

    public String getConnectionFactoryProperties()

  Description copied from interface: `OpenJPAConfiguration`
  Configuration properties for the connection factory.

  Specified by:
    `getConnectionFactoryProperties` in interface `OpenJPAConfiguration`

### getConnectionFactoryMode

    public String getConnectionFactoryMode()

  Description copied from interface: `OpenJPAConfiguration`
  The mode of the connection factory in use. Available options are:
  - local: OpenJPA controls the connections.
  - managed: Connections are automatically enlisted in the current global transaction by an application server.
  Defaults to local.

  Specified by:
    `getConnectionFactoryMode` in interface `OpenJPAConfiguration`

### setConnectionFactoryMode

    public void setConnectionFactoryMode(String mode)

  Description copied from interface: `OpenJPAConfiguration`
  The mode of the connection factory in use. Available options are:
  - local: OpenJPA controls the connections.
  - managed: Connections are automatically enlisted in the current global transaction by an application server.
  Defaults to local.

  Specified by:
    `setConnectionFactoryMode` in interface `OpenJPAConfiguration`

### isConnectionFactoryModeManaged

    public boolean isConnectionFactoryModeManaged()

  Description copied from interface: `OpenJPAConfiguration`
  Whether connections are automatically enlisted in global transactions.

  Specified by:
    `isConnectionFactoryModeManaged` in interface `OpenJPAConfiguration`

### setConnectionFactoryModeManaged

    public void setConnectionFactoryModeManaged(boolean managed)

  Description copied from interface: `OpenJPAConfiguration`
  Whether connections are automatically enlisted in global transactions.

  Specified by:
    `setConnectionFactoryModeManaged` in interface `OpenJPAConfiguration`

### setConnectionFactoryName

    public void setConnectionFactoryName(String connectionFactoryName)

  Description copied from interface: `OpenJPAConfiguration`
  The name for the data store connection factory.

  Specified by:
    `setConnectionFactoryName` in interface `OpenJPAConfiguration`

### getConnectionFactoryName

    public String getConnectionFactoryName()

  Description copied from interface: `OpenJPAConfiguration`
  The name for the data store connection factory.

  Specified by:
    `getConnectionFactoryName` in interface `OpenJPAConfiguration`

### setConnectionFactory

    public void setConnectionFactory(Object factory)

  Description copied from interface: `OpenJPAConfiguration`
  The connection factory.

  Specified by:
    `setConnectionFactory` in interface `OpenJPAConfiguration`

### getConnectionFactory

    public Object getConnectionFactory()

  Description copied from interface: `OpenJPAConfiguration`
  The connection factory, possibly from JNDI.

  Specified by:
    `getConnectionFactory` in interface `OpenJPAConfiguration`

### setConnection2UserName

    public void setConnection2UserName(String connection2UserName)

  Description copied from interface: `OpenJPAConfiguration`
  The user name for the non-XA data store connection.

  Specified by:
    `setConnection2UserName` in interface `OpenJPAConfiguration`

### getConnection2UserName

    public String getConnection2UserName()

  Description copied from interface: `OpenJPAConfiguration`
  The user name for the non-XA data store connection.

  Specified by:
    `getConnection2UserName` in interface `OpenJPAConfiguration`

### setConnection2Password

    public void setConnection2Password(String connection2Password)

  Description copied from interface: `OpenJPAConfiguration`
  The password for the non-XA data store connection.

  Specified by:
    `setConnection2Password` in interface `OpenJPAConfiguration`

### getConnection2Password

    public String getConnection2Password()

  Description copied from interface: `OpenJPAConfiguration`
  The password for the non-XA data store connection.

  Specified by:
    `getConnection2Password` in interface `OpenJPAConfiguration`

### setConnection2URL

    public void setConnection2URL(String connection2URL)

  Description copied from interface: `OpenJPAConfiguration`
  The URL for the non-XA data store connection.

  Specified by:
    `setConnection2URL` in interface `OpenJPAConfiguration`

### getConnection2URL

    public String getConnection2URL()

  Description copied from interface: `OpenJPAConfiguration`
  The URL for the non-XA data store connection.

  Specified by:
    `getConnection2URL` in interface `OpenJPAConfiguration`

### setConnection2DriverName

    public void setConnection2DriverName(String driverName)

  Description copied from interface: `OpenJPAConfiguration`
  Class name of the non-XA connection driver.

  Specified by:
    `setConnection2DriverName` in interface `OpenJPAConfiguration`

### getConnection2DriverName

    public String getConnection2DriverName()

  Description copied from interface: `OpenJPAConfiguration`
  Class name of the non-XA connection driver.

  Specified by:
    `getConnection2DriverName` in interface `OpenJPAConfiguration`

### setConnection2Properties

    public void setConnection2Properties(String connection2Properties)

  Description copied from interface: `OpenJPAConfiguration`
  These properties provide any additional information needed to establish non-XA connections.

  Specified by:
    `setConnection2Properties` in interface `OpenJPAConfiguration`

### getConnection2Properties

    public String getConnection2Properties()

  Description copied from interface: `OpenJPAConfiguration`
  These properties provide any additional information needed to establish non-XA connections.

  Specified by:
    `getConnection2Properties` in interface `OpenJPAConfiguration`

### setConnectionFactory2Properties

    public void setConnectionFactory2Properties(String connectionFactory2Properties)

  Description copied from interface: `OpenJPAConfiguration`
  Configuration properties for the non-XA connection factory.

  Specified by:
    `setConnectionFactory2Properties` in interface `OpenJPAConfiguration`

### getConnectionFactory2Properties

    public String getConnectionFactory2Properties()

  Description copied from interface: `OpenJPAConfiguration`
  Configuration properties for the non-XA connection factory.

  Specified by:
    `getConnectionFactory2Properties` in interface `OpenJPAConfiguration`

### setConnectionFactory2Name

    public void setConnectionFactory2Name(String connectionFactory2Name)

  Description copied from interface: `OpenJPAConfiguration`
  The name for the second data store connection factory.

  Specified by:
    `setConnectionFactory2Name` in interface `OpenJPAConfiguration`

### getConnectionFactory2Name

    public String getConnectionFactory2Name()

  Description copied from interface: `OpenJPAConfiguration`
  The name for the second data store connection factory.

  Specified by:
    `getConnectionFactory2Name` in interface `OpenJPAConfiguration`

### setConnectionFactory2

    public void setConnectionFactory2(Object factory)

  Description copied from interface: `OpenJPAConfiguration`
  The non-XA connection factory.

  Specified by:
    `setConnectionFactory2` in interface `OpenJPAConfiguration`

### getConnectionFactory2

    public Object getConnectionFactory2()

  Description copied from interface: `OpenJPAConfiguration`
  The non-XA connection factory.

  Specified by:
    `getConnectionFactory2` in interface `OpenJPAConfiguration`

### setOptimistic

    public void setOptimistic(boolean optimistic)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to use optimistic transactions by default.

  Specified by:
    `setOptimistic` in interface `OpenJPAConfiguration`

### setOptimistic

    public void setOptimistic(Boolean optimistic)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setOptimistic(boolean)`.

  Specified by:
    `setOptimistic` in interface `OpenJPAConfiguration`

### getOptimistic

    public boolean getOptimistic()

  Description copied from interface: `OpenJPAConfiguration`
  Whether to use optimistic transactions by default.

  Specified by:
    `getOptimistic` in interface `OpenJPAConfiguration`

### setAutoClear

    public void setAutoClear(String clear)

  Description copied from interface: `OpenJPAConfiguration`
  Whether instances clear their state when entering a transaction.

  Specified by:
    `setAutoClear` in interface `OpenJPAConfiguration`

### getAutoClear

    public String getAutoClear()

  Description copied from interface: `OpenJPAConfiguration`
  Whether instances clear their state when entering a transaction.

  Specified by:
    `getAutoClear` in interface `OpenJPAConfiguration`

### setAutoClear

    public void setAutoClear(int clear)

  Description copied from interface: `OpenJPAConfiguration`
  Whether instances clear their state when entering a transaction.

  Specified by:
    `setAutoClear` in interface `OpenJPAConfiguration`

### getAutoClearConstant

    public int getAutoClearConstant()

  Description copied from interface: `OpenJPAConfiguration`
  Return the `AutoClear` constant.

  Specified by:
    `getAutoClearConstant` in interface `OpenJPAConfiguration`

### setRetainState

    public void setRetainState(boolean retainState)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to retain state after a transaction by default.

  Specified by:
    `setRetainState` in interface `OpenJPAConfiguration`

### setRetainState

    public void setRetainState(Boolean retainState)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setRetainState(boolean)`.

  Specified by:
    `setRetainState` in interface `OpenJPAConfiguration`

### getRetainState

    public boolean getRetainState()

  Description copied from interface: `OpenJPAConfiguration`
  Whether to retain state after a transaction by default.

  Specified by:
    `getRetainState` in interface `OpenJPAConfiguration`

### setRestoreState

    public void setRestoreState(String restoreState)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to restore initial state on rollback by default.

  Specified by:
    `setRestoreState` in interface `OpenJPAConfiguration`

### getRestoreState

    public String getRestoreState()

  Description copied from interface: `OpenJPAConfiguration`
  Whether to restore initial state on rollback by default.

  Specified by:
    `getRestoreState` in interface `OpenJPAConfiguration`

### setRestoreState

    public void setRestoreState(int restoreState)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to restore initial state on rollback by default.

  Specified by:
    `setRestoreState` in interface `OpenJPAConfiguration`

### getRestoreStateConstant

    public int getRestoreStateConstant()

  Description copied from interface: `OpenJPAConfiguration`
  Return the `RestoreState` constant.

  Specified by:
    `getRestoreStateConstant` in interface `OpenJPAConfiguration`

### setAutoDetach

    public void setAutoDetach(String autoDetach)

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separated list of events which trigger auto-detachment in place of managed states. Possible values are:
  - `commit`: When the current transaction commits.
  - `close`: When the broker closes.
  - `nontx-read`: When instances are read non-transactionally.

  Specified by:
    `setAutoDetach` in interface `OpenJPAConfiguration`

### getAutoDetach

    public String getAutoDetach()

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separated list of events which trigger auto-detachment in place of managed states. Possible values are:
  - `commit`: When the current transaction commits.
  - `close`: When the broker closes.
  - `nontx-read`: When instances are read non-transactionally.

  Specified by:
    `getAutoDetach` in interface `OpenJPAConfiguration`

### setAutoDetach

    public void setAutoDetach(int autoDetachFlags)

  Description copied from interface: `OpenJPAConfiguration`
  The `AutoDetach` flags.

  Specified by:
    `setAutoDetach` in interface `OpenJPAConfiguration`

### getAutoDetachConstant

    public int getAutoDetachConstant()

  Description copied from interface: `OpenJPAConfiguration`
  The `AutoDetach` flags.

  Specified by:
    `getAutoDetachConstant` in interface `OpenJPAConfiguration`

### setDetachState

    public void setDetachState(String detachState)

  Description copied from interface: `OpenJPAConfiguration`
  Which field values to include when detaching.

  Specified by:
    `setDetachState` in interface `OpenJPAConfiguration`

### getDetachState

    public String getDetachState()

### setDetachState

    public void setDetachState(DetachOptions detachState)

  Description copied from interface: `OpenJPAConfiguration`
  Return the instance specified by the detach state plugin.

  Specified by:
    `setDetachState` in interface `OpenJPAConfiguration`

### getDetachStateInstance

    public DetachOptions getDetachStateInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Return the instance specified by the detach state plugin.

  Specified by:
    `getDetachStateInstance` in interface `OpenJPAConfiguration`

### setIgnoreChanges

    public void setIgnoreChanges(boolean ignoreChanges)

  Description copied from interface: `OpenJPAConfiguration`
  Whether changes in the current transaction are taken into account when executing queries and iterating extents.

  Specified by:
    `setIgnoreChanges` in interface `OpenJPAConfiguration`

### setIgnoreChanges

    public void setIgnoreChanges(Boolean ignoreChanges)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setIgnoreChanges(boolean)`.

  Specified by:
    `setIgnoreChanges` in interface `OpenJPAConfiguration`

### getIgnoreChanges

    public boolean getIgnoreChanges()

  Description copied from interface: `OpenJPAConfiguration`
  Whether changes in the current transaction are taken into account when executing queries and iterating extents.

  Specified by:
    `getIgnoreChanges` in interface `OpenJPAConfiguration`

### setNontransactionalRead

    public void setNontransactionalRead(boolean nontransactionalRead)

  Description copied from interface: `OpenJPAConfiguration`
  Whether persistent state is accessible outside a transaction by default.

  Specified by:
    `setNontransactionalRead` in interface `OpenJPAConfiguration`

### setNontransactionalRead

    public void setNontransactionalRead(Boolean nontransactionalRead)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setNontransactionalRead(boolean)`.

  Specified by:
    `setNontransactionalRead` in interface `OpenJPAConfiguration`

### getNontransactionalRead

    public boolean getNontransactionalRead()

  Description copied from interface: `OpenJPAConfiguration`
  Whether persistent state is accessible outside a transaction by default.

  Specified by:
    `getNontransactionalRead` in interface `OpenJPAConfiguration`

### setNontransactionalWrite

    public void setNontransactionalWrite(boolean nontransactionalWrite)

  Description copied from interface: `OpenJPAConfiguration`
  Whether persistent state can be modified outside a transaction by default.

  Specified by:
    `setNontransactionalWrite` in interface `OpenJPAConfiguration`

### setNontransactionalWrite

    public void setNontransactionalWrite(Boolean nontransactionalWrite)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setNontransactionalWrite(boolean)`.

  Specified by:
    `setNontransactionalWrite` in interface `OpenJPAConfiguration`

### getNontransactionalWrite

    public boolean getNontransactionalWrite()

  Description copied from interface: `OpenJPAConfiguration`
  Whether persistent state can be modified outside a transaction by default.

  Specified by:
    `getNontransactionalWrite` in interface `OpenJPAConfiguration`

### setMultithreaded

    public void setMultithreaded(boolean multithreaded)

  Description copied from interface: `OpenJPAConfiguration`
  Whether brokers or their managed objects will be used by multiple concurrent threads.

  Specified by:
    `setMultithreaded` in interface `OpenJPAConfiguration`

### setMultithreaded

    public void setMultithreaded(Boolean multithreaded)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setMultithreaded(boolean)`.

  Specified by:
    `setMultithreaded` in interface `OpenJPAConfiguration`

### getMultithreaded

    public boolean getMultithreaded()

  Description copied from interface: `OpenJPAConfiguration`
  Whether brokers or their managed objects will be used by multiple concurrent threads.

  Specified by:
    `getMultithreaded` in interface `OpenJPAConfiguration`

### setFetchBatchSize

    public void setFetchBatchSize(int fetchBatchSize)

  Description copied from interface: `OpenJPAConfiguration`
  Set the size of the batch that will be pre-selected when accessing elements in a query or relationship. Use -1 to prefetch all results.

  Specified by:
    `setFetchBatchSize` in interface `OpenJPAConfiguration`

### setFetchBatchSize

    public void setFetchBatchSize(Integer fetchBatchSize)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setFetchBatchSize(int)`.

  Specified by:
    `setFetchBatchSize` in interface `OpenJPAConfiguration`

### getFetchBatchSize

    public int getFetchBatchSize()

  Description copied from interface: `OpenJPAConfiguration`
  Get the size of the batch that will be pre-selected when accessing elements in a query or relationship. Use -1 to prefetch all results.

  Specified by:
    `getFetchBatchSize` in interface `OpenJPAConfiguration`

### setMaxFetchDepth

    public void setMaxFetchDepth(int maxFetchDepth)

  Description copied from interface: `OpenJPAConfiguration`
  The maximum relation depth to traverse when eager fetching. Use -1 for no limit.

  Specified by:
    `setMaxFetchDepth` in interface `OpenJPAConfiguration`

### setMaxFetchDepth

    public void setMaxFetchDepth(Integer maxFetchDepth)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setMaxFetchDepth(int)`.

  Specified by:
    `setMaxFetchDepth` in interface `OpenJPAConfiguration`

### getMaxFetchDepth

    public int getMaxFetchDepth()

  Description copied from interface: `OpenJPAConfiguration`
  The maximum relation depth to traverse when eager fetching. Use -1 for no limit.

  Specified by:
    `getMaxFetchDepth` in interface `OpenJPAConfiguration`

### setFetchGroups

    public void setFetchGroups(String fetchGroups)

  Description copied from interface: `OpenJPAConfiguration`
  Comma-separated list of fetch group names that will be pre-set for all new `FetchConfiguration`s.

  Specified by:
    `setFetchGroups` in interface `OpenJPAConfiguration`

### getFetchGroups

    public String getFetchGroups()

  Description copied from interface: `OpenJPAConfiguration`
  Comma-separated list of fetch group names that will be pre-set for all new `FetchConfiguration`s.

  Specified by:
    `getFetchGroups` in interface `OpenJPAConfiguration`

### getFetchGroupsList

    public String[] getFetchGroupsList()

  Description copied from interface: `OpenJPAConfiguration`
  List of fetch group names that will be pre-set for all new `FetchConfiguration`s.

  Specified by:
    `getFetchGroupsList` in interface `OpenJPAConfiguration`

### setFetchGroups

    public void setFetchGroups(String[] fetchGroups)

  Description copied from interface: `OpenJPAConfiguration`
  List of fetch group names that will be pre-set for all new `FetchConfiguration`s.

  Specified by:
    `setFetchGroups` in interface `OpenJPAConfiguration`

### setFlushBeforeQueries

    public void setFlushBeforeQueries(String flush)

  Description copied from interface: `OpenJPAConfiguration`
  Sets whether or not OpenJPA should automatically flush modifications to the data store before executing queries.

  Specified by:
    `setFlushBeforeQueries` in interface `OpenJPAConfiguration`

### getFlushBeforeQueries

    public String getFlushBeforeQueries()

  Description copied from interface: `OpenJPAConfiguration`
  Returns whether or not OpenJPA should automatically flush modifications to the data store before executing queries.

  Specified by:
    `getFlushBeforeQueries` in interface `OpenJPAConfiguration`

### setFlushBeforeQueries

    public void setFlushBeforeQueries(int flush)

  Description copied from interface: `OpenJPAConfiguration`
  Set to one of `QueryFlushModes.FLUSH_TRUE`, `QueryFlushModes.FLUSH_FALSE`, or `QueryFlushModes.FLUSH_WITH_CONNECTION`.

  Specified by:
    `setFlushBeforeQueries` in interface `OpenJPAConfiguration`

### getFlushBeforeQueriesConstant

    public int getFlushBeforeQueriesConstant()

  Description copied from interface: `OpenJPAConfiguration`
  Returns one of `QueryFlushModes.FLUSH_TRUE`, `QueryFlushModes.FLUSH_FALSE`, or `QueryFlushModes.FLUSH_WITH_CONNECTION`, as determined by parsing the string returned by `OpenJPAConfiguration.getFlushBeforeQueries()`.

  Specified by:
    `getFlushBeforeQueriesConstant` in interface `OpenJPAConfiguration`

### setLockTimeout

    public void setLockTimeout(int timeout)

  Description copied from interface: `OpenJPAConfiguration`
  The time to wait for an object lock in milliseconds, or -1 for no timeout.

  Specified by:
    `setLockTimeout` in interface `OpenJPAConfiguration`

### setLockTimeout

    public void setLockTimeout(Integer timeout)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setLockTimeout(int)`.

  Specified by:
    `setLockTimeout` in interface `OpenJPAConfiguration`

### getLockTimeout

    public int getLockTimeout()

  Description copied from interface: `OpenJPAConfiguration`
  The time to wait for an object lock in milliseconds, or -1 for no timeout.

  Specified by:
    `getLockTimeout` in interface `OpenJPAConfiguration`

### getQueryTimeout

    public int getQueryTimeout()

  Description copied from interface: `OpenJPAConfiguration`
  The time to wait for a query to execute in milliseconds, or -1 for no timeout.

  Specified by:
    `getQueryTimeout` in interface `OpenJPAConfiguration`

### setQueryTimeout

    public void setQueryTimeout(int timeout)

  Description copied from interface: `OpenJPAConfiguration`
  The time to wait for a query to execute in milliseconds, or -1 for no timeout.

  Specified by:
    `setQueryTimeout` in interface `OpenJPAConfiguration`

### setReadLockLevel

    public void setReadLockLevel(String level)

  Description copied from interface: `OpenJPAConfiguration`
  The default read lock level to use during non-optimistic transactions. Defaults to `read`.

  Specified by:
    `setReadLockLevel` in interface `OpenJPAConfiguration`

### getReadLockLevel

    public String getReadLockLevel()

  Description copied from interface: `OpenJPAConfiguration`
  The default read lock level to use during non-optimistic transactions. Defaults to `read`.

  Specified by:
    `getReadLockLevel` in interface `OpenJPAConfiguration`

### setReadLockLevel

    public void setReadLockLevel(int level)

  Description copied from interface: `OpenJPAConfiguration`
  The numeric read lock level.

  Specified by:
    `setReadLockLevel` in interface `OpenJPAConfiguration`

### getReadLockLevelConstant

    public int getReadLockLevelConstant()

  Description copied from interface: `OpenJPAConfiguration`
  The numeric read lock level.

  Specified by:
    `getReadLockLevelConstant` in interface `OpenJPAConfiguration`

### setWriteLockLevel

    public void setWriteLockLevel(String level)

  Description copied from interface: `OpenJPAConfiguration`
  The default write lock level to use during non-optimistic transactions. Defaults to `write`.

  Specified by:
    `setWriteLockLevel` in interface `OpenJPAConfiguration`

### getWriteLockLevel

    public String getWriteLockLevel()

  Description copied from interface: `OpenJPAConfiguration`
  The default write lock level to use during non-optimistic transactions. Defaults to `write`.

  Specified by:
    `getWriteLockLevel` in interface `OpenJPAConfiguration`

### setWriteLockLevel

    public void setWriteLockLevel(int level)

  Description copied from interface: `OpenJPAConfiguration`
  The numeric write lock level.

  Specified by:
    `setWriteLockLevel` in interface `OpenJPAConfiguration`

### getWriteLockLevelConstant

    public int getWriteLockLevelConstant()

  Description copied from interface: `OpenJPAConfiguration`
  The numeric write lock level.

  Specified by:
    `getWriteLockLevelConstant` in interface `OpenJPAConfiguration`

### setSequence

    public void setSequence(String sequence)

  Description copied from interface: `OpenJPAConfiguration`
  Plugin string for the default system `Seq`.

  Specified by:
    `setSequence` in interface `OpenJPAConfiguration`

### getSequence

    public String getSequence()

  Description copied from interface: `OpenJPAConfiguration`
  Plugin string for the default system `Seq`.

  Specified by:
    `getSequence` in interface `OpenJPAConfiguration`

### setSequence

    public void setSequence(Seq seq)

  Description copied from interface: `OpenJPAConfiguration`
  The default system sequence.

  Specified by:
    `setSequence` in interface `OpenJPAConfiguration`

### getSequenceInstance

    public Seq getSequenceInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The default system sequence.

  Specified by:
    `getSequenceInstance` in interface `OpenJPAConfiguration`

### setConnectionRetainMode

    public void setConnectionRetainMode(String connectionRetainMode)

  Description copied from interface: `OpenJPAConfiguration`
  Specifies the behavior of the broker with respect to data store connections. Possible values are:
  - `always`: Each broker obtains a single connection and uses it until the broker is closed.
  - `transaction`: A connection is obtained when each transaction begins (optimistic or datastore), and is released when the transaction completes.
  - `on-demand`: Connections are obtained only when needed. This is the default mode. It is equivalent to the previous option when datastore transactions are used. For optimistic transactions, though, it means that a connection will be retained only for the duration of the data store commit process.

  Specified by:
    `setConnectionRetainMode` in interface `OpenJPAConfiguration`

### getConnectionRetainMode

    public String getConnectionRetainMode()

  Description copied from interface: `OpenJPAConfiguration`
  Specifies the behavior of the broker with respect to data store connections. Possible values are:
  - `always`: Each broker obtains a single connection and uses it until the broker is closed.
  - `transaction`: A connection is obtained when each transaction begins (optimistic or datastore), and is released when the transaction completes.
  - `on-demand`: Connections are obtained only when needed. This is the default mode. It is equivalent to the previous option when datastore transactions are used. For optimistic transactions, though, it means that a connection will be retained only for the duration of the data store commit process.

  Specified by:
    `getConnectionRetainMode` in interface `OpenJPAConfiguration`

### setConnectionRetainMode

    public void setConnectionRetainMode(int connectionRetainMode)

  Description copied from interface: `OpenJPAConfiguration`
  Set the connection retain mode as one of the following symbolic constants:
  - `ConnectionRetainModes.CONN_RETAIN_ALWAYS`
  - `ConnectionRetainModes.CONN_RETAIN_TRANS`
  - `ConnectionRetainModes.CONN_RETAIN_DEMAND`

  Specified by:
    `setConnectionRetainMode` in interface `OpenJPAConfiguration`

### getConnectionRetainModeConstant

    public int getConnectionRetainModeConstant()

  Description copied from interface: `OpenJPAConfiguration`
  Return the connection retain mode as one of the following symbolic constants:
  - `ConnectionRetainModes.CONN_RETAIN_ALWAYS`
  - `ConnectionRetainModes.CONN_RETAIN_TRANS`
  - `ConnectionRetainModes.CONN_RETAIN_DEMAND`

  Specified by:
    `getConnectionRetainModeConstant` in interface `OpenJPAConfiguration`

### setFilterListeners

    public void setFilterListeners(String filterListeners)

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separted list of the plugin strings of the query `FilterListener`s to use.

  Specified by:
    `setFilterListeners` in interface `OpenJPAConfiguration`

### getFilterListeners

    public String getFilterListeners()

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separted list of the plugin strings of the query `FilterListener`s to use.

  Specified by:
    `getFilterListeners` in interface `OpenJPAConfiguration`

### setFilterListeners

    public void setFilterListeners(FilterListener[] listeners)

  Description copied from interface: `OpenJPAConfiguration`
  Set the query filter listeners. Overrides the list of listener classes.

  Specified by:
    `setFilterListeners` in interface `OpenJPAConfiguration`

### getFilterListenerInstances

    public FilterListener[] getFilterListenerInstances()

  Description copied from interface: `OpenJPAConfiguration`
  Return the query filter listeners. If none have been set explicitly, this method instantiates the listeners from the set plugin list.

  Specified by:
    `getFilterListenerInstances` in interface `OpenJPAConfiguration`

### setAggregateListeners

    public void setAggregateListeners(String aggregateListeners)

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separted list of the plugin strings of the query `AggregateListener`s to use.

  Specified by:
    `setAggregateListeners` in interface `OpenJPAConfiguration`

### getAggregateListeners

    public String getAggregateListeners()

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separted list of the plugin strings of the query `AggregateListener`s to use.

  Specified by:
    `getAggregateListeners` in interface `OpenJPAConfiguration`

### setAggregateListeners

    public void setAggregateListeners(AggregateListener[] listeners)

  Description copied from interface: `OpenJPAConfiguration`
  Set the query function listeners. Overrides the list of listener classes.

  Specified by:
    `setAggregateListeners` in interface `OpenJPAConfiguration`

### getAggregateListenerInstances

    public AggregateListener[] getAggregateListenerInstances()

  Description copied from interface: `OpenJPAConfiguration`
  Return the query function listeners. If none have been set explicitly, this method instantiates the listeners from the set plugin list.

  Specified by:
    `getAggregateListenerInstances` in interface `OpenJPAConfiguration`

### setRetryClassRegistration

    public void setRetryClassRegistration(boolean retry)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to warn and defer registration instead of throwing an exception when a registered persistent class cannot be processed. Should only be set to true in complex classloader topologies. Defaults to `false`.

  Specified by:
    `setRetryClassRegistration` in interface `OpenJPAConfiguration`

### setRetryClassRegistration

    public void setRetryClassRegistration(Boolean retry)

  Description copied from interface: `OpenJPAConfiguration`
  Wrapper for JCA usage of `OpenJPAConfiguration.setRetryClassRegistration(boolean)`.

  Specified by:
    `setRetryClassRegistration` in interface `OpenJPAConfiguration`

### getRetryClassRegistration

    public boolean getRetryClassRegistration()

  Description copied from interface: `OpenJPAConfiguration`
  Whether to warn and defer registration instead of throwing an exception when a registered persistent class cannot be processed. Should only be set to true in complex classloader topologies. Defaults to `false`.

  Specified by:
    `getRetryClassRegistration` in interface `OpenJPAConfiguration`

### getCompatibility

    public String getCompatibility()

  Description copied from interface: `OpenJPAConfiguration`
  Backwards compatibility options.

  Specified by:
    `getCompatibility` in interface `OpenJPAConfiguration`

### setCompatibility

    public void setCompatibility(String compatibility)

  Description copied from interface: `OpenJPAConfiguration`
  Backwards compatibility options.

  Specified by:
    `setCompatibility` in interface `OpenJPAConfiguration`

### getCompatibilityInstance

    public Compatibility getCompatibilityInstance()

  If a Compatibility instance is associated with the Specification, we will configure this Compatibility instance instead of instantiating a new one so that the compatibility flags set in compliance with the Specification can be preserved.

  Specified by:
    `getCompatibilityInstance` in interface `OpenJPAConfiguration`

### getCallbackOptions

    public String getCallbackOptions()

  Description copied from interface: `OpenJPAConfiguration`
  Options for configuring callbacks as a String.

  Specified by:
    `getCallbackOptions` in interface `OpenJPAConfiguration`

### setCallbackOptions

    public void setCallbackOptions(String options)

  Description copied from interface: `OpenJPAConfiguration`
  Options for configuring callbacks set as a comma-separated string value pair.

  Specified by:
    `setCallbackOptions` in interface `OpenJPAConfiguration`

### getCallbackOptionsInstance

    public CallbackOptions getCallbackOptionsInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Options for configuring callbacks.

  Specified by:
    `getCallbackOptionsInstance` in interface `OpenJPAConfiguration`

### getQueryCompilationCache

    public String getQueryCompilationCache()

  Description copied from interface: `OpenJPAConfiguration`
  Configuration settings for the query compilation cache to use.

  Specified by:
    `getQueryCompilationCache` in interface `OpenJPAConfiguration`
  See Also:
    `QueryCompilationCacheValue`

### setQueryCompilationCache

    public void setQueryCompilationCache(String queryCompilationCache)

  Description copied from interface: `OpenJPAConfiguration`
  Configuration settings for the query compilation cache to use.

  Specified by:
    `setQueryCompilationCache` in interface `OpenJPAConfiguration`
  See Also:
    `QueryCompilationCacheValue`

### getQueryCompilationCacheInstance

    public Map getQueryCompilationCacheInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Configuration settings for the query compilation cache to use.

  Specified by:
    `getQueryCompilationCacheInstance` in interface `OpenJPAConfiguration`
  See Also:
    `QueryCompilationCacheValue`

### getStoreFacadeTypeRegistry

    public StoreFacadeTypeRegistry getStoreFacadeTypeRegistry()

  Description copied from interface: `OpenJPAConfiguration`
  Return the `StoreFacadeTypeRegistry` instance associated with this configuration.

  Specified by:
    `getStoreFacadeTypeRegistry` in interface `OpenJPAConfiguration`

### getBrokerFactoryEventManager

    public BrokerFactoryEventManager getBrokerFactoryEventManager()

  Description copied from interface: `OpenJPAConfiguration`
  Return the `BrokerFactoryEventManager` associated with this configuration.

  Specified by:
    `getBrokerFactoryEventManager` in interface `OpenJPAConfiguration`

### getRuntimeUnenhancedClasses

    public String getRuntimeUnenhancedClasses()

  Description copied from interface: `OpenJPAConfiguration`
  Specifies how OpenJPA handles unenhanced types. Possible values are:
  - `supported`: Runtime optimization of persistent types is available. This is the default
  - `unsupported`: Runtime optimization of persistent types is not available. An exception will be thrown if the system loads with persistent types that are not enhanced.
  - `warn`: Runtime optimization of persistent types is not available, but no exception will be thrown initially. A warning will be logged instead. It is likely that the system will fail at a later point. This might be suitable for environments with complex classloader configurations.

  Specified by:
    `getRuntimeUnenhancedClasses` in interface `OpenJPAConfiguration`

### getRuntimeUnenhancedClassesConstant

    public int getRuntimeUnenhancedClassesConstant()

  Description copied from interface: `OpenJPAConfiguration`
  Return the runtime class optimization setting as one of the following symbolic constants:
  - `RuntimeUnenhancedClassesModes.SUPPORTED`
  - `RuntimeUnenhancedClassesModes.UNSUPPORTED`
  - `RuntimeUnenhancedClassesModes.WARN`

  Specified by:
    `getRuntimeUnenhancedClassesConstant` in interface `OpenJPAConfiguration`

### setRuntimeUnenhancedClasses

    public void setRuntimeUnenhancedClasses(int mode)

  Description copied from interface: `OpenJPAConfiguration`
  Set the runtime class optimization setting as one of the following symbolic constants:
  - `RuntimeUnenhancedClassesModes.SUPPORTED`
  - `RuntimeUnenhancedClassesModes.UNSUPPORTED`
  - `RuntimeUnenhancedClassesModes.WARN`

  Specified by:
    `setRuntimeUnenhancedClasses` in interface `OpenJPAConfiguration`

### setRuntimeUnenhancedClasses

    public void setRuntimeUnenhancedClasses(String mode)

  Description copied from interface: `OpenJPAConfiguration`
  Specifies how OpenJPA handles unenhanced types.

  Specified by:
    `setRuntimeUnenhancedClasses` in interface `OpenJPAConfiguration`
  See Also:
    `#getRuntimeUnenhancedClasses()}`

### getCacheMarshallers

    public String getCacheMarshallers()

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separted list of the plugin strings specifying the `CacheMarshaller`s to use.

  Specified by:
    `getCacheMarshallers` in interface `OpenJPAConfiguration`

### setCacheMarshallers

    public void setCacheMarshallers(String marshallers)

  Description copied from interface: `OpenJPAConfiguration`
  A comma-separated list of the plugin strings specifying the `CacheMarshaller`s to use.

  Specified by:
    `setCacheMarshallers` in interface `OpenJPAConfiguration`

### getCacheMarshallerInstances

    public Map getCacheMarshallerInstances()

  Description copied from interface: `OpenJPAConfiguration`
  Return the cache marshaller listeners.

  Specified by:
    `getCacheMarshallerInstances` in interface `OpenJPAConfiguration`

### isInitializeEagerly

    public boolean isInitializeEagerly()

  Description copied from interface: `OpenJPAConfiguration`
  Affirms if all configured elements are initialized eagerly as opposed to lazily on-demand.

  Specified by:
    `isInitializeEagerly` in interface `OpenJPAConfiguration`

### setInitializeEagerly

    public void setInitializeEagerly(boolean retry)

  Description copied from interface: `OpenJPAConfiguration`
  Sets whether all configured elements will be initialized eagerly or lazily on-demand.

  Specified by:
    `setInitializeEagerly` in interface `OpenJPAConfiguration`

### setValidationMode

    public void setValidationMode(String mode)

  Description copied from interface: `OpenJPAConfiguration`
  Set the bean validation mode to use for managed classes. If not set, defaults to `AUTO`.

  Specified by:
    `setValidationMode` in interface `OpenJPAConfiguration`

### getValidationMode

    public String getValidationMode()

  Description copied from interface: `OpenJPAConfiguration`
  The bean validation mode to use for managed classes. Defaults to `AUTO`.

  Specified by:
    `getValidationMode` in interface `OpenJPAConfiguration`

### setValidationGroupPrePersist

    public void setValidationGroupPrePersist(String vgPrePersist)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the validation groups for pre-persist

  Specified by:
    `setValidationGroupPrePersist` in interface `OpenJPAConfiguration`

### getValidationGroupPrePersist

    public String getValidationGroupPrePersist()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the validation groups for pre-persist

  Specified by:
    `getValidationGroupPrePersist` in interface `OpenJPAConfiguration`

### setValidationGroupPreUpdate

    public void setValidationGroupPreUpdate(String vgPreUpdate)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the validation groups for pre-update

  Specified by:
    `setValidationGroupPreUpdate` in interface `OpenJPAConfiguration`

### getValidationGroupPreUpdate

    public String getValidationGroupPreUpdate()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the validation groups for pre-update

  Specified by:
    `getValidationGroupPreUpdate` in interface `OpenJPAConfiguration`

### setValidationGroupPreRemove

    public void setValidationGroupPreRemove(String vgPreRemove)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the validation groups for pre-remove

  Specified by:
    `setValidationGroupPreRemove` in interface `OpenJPAConfiguration`

### getValidationGroupPreRemove

    public String getValidationGroupPreRemove()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the validation groups for pre-remove

  Specified by:
    `getValidationGroupPreRemove` in interface `OpenJPAConfiguration`

### getInstrumentation

    public String getInstrumentation()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the plug-in string that defines instrumentation providers and what they instrument.

  Specified by:
    `getInstrumentation` in interface `OpenJPAConfiguration`
  Returns:
    a plug-in string for the instrumentation configuration

### setInstrumentation

    public void setInstrumentation(String providers)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the plug-in string that defines instrumentation providers and what they instrument.

  Specified by:
    `setInstrumentation` in interface `OpenJPAConfiguration`
  Parameters:
    `providers` - a plug-in string for the instrumentation configuration

### getInstrumentationInstances

    public InstrumentationProvider[] getInstrumentationInstances()

### setInstrumentationManager

    public void setInstrumentationManager(String mgr)

### getInstrumentationManager

    public String getInstrumentationManager()

### setInstrumentationManager

    public void setInstrumentationManager(InstrumentationManager im)

### getInstrumentationManagerInstance

    public InstrumentationManager getInstrumentationManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Gets an instance of the instrumentation manager. The instrumentation provides access to configured instrumentation providers and can be used to manage them at runtime.

  Specified by:
    `getInstrumentationManagerInstance` in interface `OpenJPAConfiguration`
  Returns:
    an instance of the instrumentation manager

### instantiateAll

    public void instantiateAll()

  Description copied from interface: `Configuration`
  Call the instantiating get methods for all values. Up-front instantiation allows one to avoid the synchronization necessary with lazy instantiation.

  Specified by:
    `instantiateAll` in interface `Configuration`
  Overrides:
    `instantiateAll` in class `ConfigurationImpl`

### preClose

    protected void preClose()

  Description copied from class: `ConfigurationImpl`
  Invoked by final method `ConfigurationImpl.close()` after invoking the `ProductDerivation.beforeConfigurationClose(org.apache.openjpa.lib.conf.Configuration)` callbacks but before performing internal close operations.

  Overrides:
    `preClose` in class `ConfigurationImpl`

### getConfigurationLog

    public Log getConfigurationLog()

  Description copied from class: `ConfigurationImpl`
  Returns the logging channel `openjpa.Runtime` by default.

  Specified by:
    `getConfigurationLog` in interface `Configuration`
  Overrides:
    `getConfigurationLog` in class `ConfigurationImpl`

### setQuerySQLCache

    public void setQuerySQLCache(String querySQLCache)

  Description copied from interface: `OpenJPAConfiguration`
  Sets QuerySQLCache with the given configuration.

  Specified by:
    `setQuerySQLCache` in interface `OpenJPAConfiguration`

### setQuerySQLCache

    public void setQuerySQLCache(PreparedQueryCache querySQLCache)

  Description copied from interface: `OpenJPAConfiguration`
  Sets QuerySQLCache with the given cache.

  Specified by:
    `setQuerySQLCache` in interface `OpenJPAConfiguration`

### getQuerySQLCache

    public String getQuerySQLCache()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the configuration of QuerySQLCache.

  Specified by:
    `getQuerySQLCache` in interface `OpenJPAConfiguration`

### getQuerySQLCacheInstance

    public PreparedQueryCache getQuerySQLCacheInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Return PreparedQueryCache used for caching datastore queries.

  Specified by:
    `getQuerySQLCacheInstance` in interface `OpenJPAConfiguration`

### setFinderCache

    public void setFinderCache(String finderCache)

  Description copied from interface: `OpenJPAConfiguration`
  Set the finder cache from a string configuration.

  Specified by:
    `setFinderCache` in interface `OpenJPAConfiguration`

### getFinderCache

    public String getFinderCache()

  Description copied from interface: `OpenJPAConfiguration`
  Get the string configuration of the finder cache.

  Specified by:
    `getFinderCache` in interface `OpenJPAConfiguration`

### getFinderCacheInstance

    public FinderCache getFinderCacheInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Get the cache of finder queries.

  Specified by:
    `getFinderCacheInstance` in interface `OpenJPAConfiguration`

### getValidationFactoryInstance

    public Object getValidationFactoryInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The ValidatorFactory provided by the container or application. Defaults to `null`.

  Specified by:
    `getValidationFactoryInstance` in interface `OpenJPAConfiguration`

### setValidationFactory

    public void setValidationFactory(Object factory)

  Description copied from interface: `OpenJPAConfiguration`
  Set the container or application provided ValidatorFactory instance. If not set, defaults to `null`.

  Specified by:
    `setValidationFactory` in interface `OpenJPAConfiguration`

### getValidatorInstance

    public Object getValidatorInstance()

  Description copied from interface: `OpenJPAConfiguration`
  The Validator provided by the container or created by the runtime. Defaults to `null`.

  Specified by:
    `getValidatorInstance` in interface `OpenJPAConfiguration`

### setValidatorInstance

    public void setValidatorInstance(Object val)

  Description copied from interface: `OpenJPAConfiguration`
  Set the container or application provided Validator instance. If not set, defaults to `null`.

  Specified by:
    `setValidatorInstance` in interface `OpenJPAConfiguration`

### getLifecycleEventManager

    public String getLifecycleEventManager()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the lifecycle event manager instance classname.

  Specified by:
    `getLifecycleEventManager` in interface `OpenJPAConfiguration`

### getLifecycleEventManagerInstance

    public LifecycleEventManager getLifecycleEventManagerInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the lifecycle event manager instance.

  Specified by:
    `getLifecycleEventManagerInstance` in interface `OpenJPAConfiguration`

### setLifecycleEventManager

    public void setLifecycleEventManager(String lem)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the lifecycle event manager instance classname.

  Specified by:
    `setLifecycleEventManager` in interface `OpenJPAConfiguration`

### getDynamicEnhancementAgent

    public boolean getDynamicEnhancementAgent()

  Description copied from interface: `OpenJPAConfiguration`
  Whether OpenJPA will attempt to dynamically load the enhancement agent.

  Specified by:
    `getDynamicEnhancementAgent` in interface `OpenJPAConfiguration`

### setDynamicEnhancementAgent

    public void setDynamicEnhancementAgent(boolean dynamic)

  Description copied from interface: `OpenJPAConfiguration`
  Sets whether OpenJPA will attempt to dynamically load the enhancement agent.

  Specified by:
    `setDynamicEnhancementAgent` in interface `OpenJPAConfiguration`

### setEncryptionProvider

    public void setEncryptionProvider(String p)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the `EncryptionProvider`.

  Specified by:
    `setEncryptionProvider` in interface `OpenJPAConfiguration`

### getEncryptionProvider

    public EncryptionProvider getEncryptionProvider()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the `EncryptionProvider`.

  Specified by:
    `getEncryptionProvider` in interface `OpenJPAConfiguration`
  Returns:
    EncryptionProvider

### setDataCacheMode

    public void setDataCacheMode(String mode)

  Description copied from interface: `OpenJPAConfiguration`
  Set the `DataCacheMode`

  Specified by:
    `setDataCacheMode` in interface `OpenJPAConfiguration`
  Parameters:
    `mode` - One of the Sting constants from `DataCacheMode`

### getDataCacheMode

    public String getDataCacheMode()

  Description copied from interface: `OpenJPAConfiguration`
  Return the String constant that matches the `DataCacheMode`

  Specified by:
    `getDataCacheMode` in interface `OpenJPAConfiguration`
  Returns:
    DataCacheMode

### getCacheDistributionPolicy

    public String getCacheDistributionPolicy()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the plug-in string that described the policy to distribute cached instances across named partitions of L2 data cache.

  Specified by:
    `getCacheDistributionPolicy` in interface `OpenJPAConfiguration`
  Returns:
    a plug-in string for `CacheDistributionPolicy`.

### getCacheDistributionPolicyInstance

    public CacheDistributionPolicy getCacheDistributionPolicyInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the policy object that determines distribution of cached instances across named partitions of L2 data cache.

  Specified by:
    `getCacheDistributionPolicyInstance` in interface `OpenJPAConfiguration`
  Returns:
    an implementation of `CacheDistributionPolicy`.

### setCacheDistributionPolicy

    public void setCacheDistributionPolicy(String policyPlugin)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the plug-in string that describes the policy to distribute cached instances across named partitions of L2 data cache.

  Specified by:
    `setCacheDistributionPolicy` in interface `OpenJPAConfiguration`

### setCacheDistributionPolicyInstance

    public void setCacheDistributionPolicyInstance(CacheDistributionPolicy policy)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the policy object that determines distribution of cached instances across named partitions of L2 data cache.

  Specified by:
    `setCacheDistributionPolicyInstance` in interface `OpenJPAConfiguration`
  Parameters:
    `policy` - a non-null implementation of `CacheDistributionPolicy`.

### setPersistenceEnvironment

    public void setPersistenceEnvironment(Map<String,Object> peMap)

### getPersistenceEnvironment

    public Map<String,Object> getPersistenceEnvironment()

### getAuditorInstance

    public Auditor getAuditorInstance()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the singular instance of `Auditor` associated with this configuration.

  Specified by:
    `getAuditorInstance` in interface `OpenJPAConfiguration`

### setAuditorInstance

    public void setAuditorInstance(Auditor auditor)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the singular instance of `Auditor` associated with this configuration.

  Specified by:
    `setAuditorInstance` in interface `OpenJPAConfiguration`

### getAuditor

    public String getAuditor()

  Description copied from interface: `OpenJPAConfiguration`
  Gets the plug-in string of `Auditor` specified in this configuration.

  Specified by:
    `getAuditor` in interface `OpenJPAConfiguration`

### setAuditor

    public void setAuditor(String auditor)

  Description copied from interface: `OpenJPAConfiguration`
  Sets the plug-in string of `Auditor` specified in this configuration.

  Specified by:
    `setAuditor` in interface `OpenJPAConfiguration`

### getPostLoadOnMerge

    public boolean getPostLoadOnMerge()

  Description copied from interface: `OpenJPAConfiguration`
  Whether to send @PostLoad events on a merge operation.

  Specified by:
    `getPostLoadOnMerge` in interface `OpenJPAConfiguration`

### setPostLoadOnMerge

    public void setPostLoadOnMerge(boolean postLoadOnMerge)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to send @PostLoad events on a merge operation.

  Specified by:
    `setPostLoadOnMerge` in interface `OpenJPAConfiguration`

### setPostLoadOnMerge

    public void setPostLoadOnMerge(Boolean postLoadOnMerge)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to send @PostLoad events on a merge operation.

  Specified by:
    `setPostLoadOnMerge` in interface `OpenJPAConfiguration`

### getOptimizeIdCopy

    public boolean getOptimizeIdCopy()

  Description copied from interface: `OpenJPAConfiguration`
  Whether to attempt to optimize id class copy operations during the enhancement process. Optimization is only applicable for simple id classes that have a constructor with the proper construction parameters and direct assignments to fields within the id class during construction. If the optimization cannot occur, the enhancer will fallback to the noraml behavior.

  Specified by:
    `getOptimizeIdCopy` in interface `OpenJPAConfiguration`

### setOptimizeIdCopy

    public void setOptimizeIdCopy(boolean optimizeId)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to attempt to optimize id class copy operations during the enhancement process. Optimization is only applicable for simple id classes that have a constructor with the proper construction parameters and direct assignments to fields within the id class during construction. If the optimization cannot occur, the enhancer will fallback to the normal behavior.

  Specified by:
    `setOptimizeIdCopy` in interface `OpenJPAConfiguration`

### setOptimizeIdCopy

    public void setOptimizeIdCopy(Boolean optimizeId)

  Description copied from interface: `OpenJPAConfiguration`
  Whether to attempt to optimize id class copy operations during the enhancement process. Optimization is only applicable for simple id classes that have a constructor with the proper construction parameters and direct assignments to fields within the id class during construction. If the optimization cannot occur, the enhancer will fallback to the normal behavior.

  Specified by:
    `setOptimizeIdCopy` in interface `OpenJPAConfiguration`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 Apache Software Foundation. All Rights Reserved.